## StorageGRID-11.9.0.8-Sources-FTP.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/toolchain.cmake"
    CACHE FILEPATH
    "Toolchain to use for building this package and dependencies")

set(HUNTER_CONFIGURATION_TYPES "Release;Debug" CACHE STRING
    "Configuration types used when building Hunter dependencies")

include(CMakeDependentOption)
include(HunterGate)

option(HUNTER_BUILD_SHARED_LIBS "Build Shared Library" ON)

HunterGate(
    URL "https://github.com/cpp-pm/hunter/archive/v0.23.249.tar.gz"
    SHA1 "d45d77d8bba9da13e9290a180e0477e90accd89b"
    LOCAL # load `${CMAKE_CURRENT_LIST_DIR}/cmake/Hunter/config.cmake`
)

project(jaegertracing VERSION 0.9.0)

option(JAEGERTRACING_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR
    CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(cxx_flags -Wall -pedantic)
  if(JAEGERTRACING_WARNINGS_AS_ERRORS)
    list(APPEND cxx_flags -Werror)
  endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  list(APPEND cxx_flags -Wno-unused-private-field)
endif()

if(MSVC)
  add_definitions(-D_SILENCE_CXX17_ITERATOR_BASE_CLASS_DEPRECATION_WARNING)

  # https://studiofreya.com/2018/01/06/visual-studio-2017-with-cpp17-and-boost/
  add_definitions(-DBOOST_CONFIG_SUPPRESS_OUTDATED_MESSAGE)
  add_definitions(-D_SCL_SECURE_NO_WARNINGS)
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

if(HUNTER_ENABLED)
  set(hunter_config "CONFIG")
else()
  set(hunter_config "")
endif()

set(package_deps)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
   CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9")
  message(FATAL_ERROR "Must use gcc >= 4.9")
endif()

hunter_add_package(thrift)
find_package(thrift ${hunter_config} REQUIRED)
if(HUNTER_ENABLED)
  list(APPEND LIBS thrift::thrift_static)
else()
  list(APPEND LIBS ${THRIFT_LIBRARIES})
endif()
list(APPEND package_deps thrift)


hunter_add_package(opentracing-cpp)
# Not `${hunter_config}` because OpenTracing provides its own
# OpenTracingConfig.cmake file
find_package(OpenTracing CONFIG REQUIRED)
# Under Windows, link dynamically with OpenTracing
if (WIN32)
  list(APPEND LIBS OpenTracing::opentracing)
  set(OPENTRACING_LIB OpenTracing::opentracing)
else()
  list(APPEND LIBS OpenTracing::opentracing-static)
  set(OPENTRACING_LIB OpenTracing::opentracing-static)
endif()
list(APPEND package_deps OpenTracing)

hunter_add_package(nlohmann_json)
find_package(nlohmann_json CONFIG REQUIRED)
list(APPEND LIBS nlohmann_json::nlohmann_json)
list(APPEND package_deps nlohmann_json)

option(JAEGERTRACING_BUILD_EXAMPLES "Build examples" ON)

option(JAEGERTRACING_COVERAGE "Build with coverage" $ENV{COVERAGE})
option(JAEGERTRACING_BUILD_CROSSDOCK "Build crossdock" $ENV{CROSSDOCK})
cmake_dependent_option(
  JAEGERTRACING_WITH_YAML_CPP "Use yaml-cpp to parse config files" ON
  "NOT JAEGERTRACING_BUILD_CROSSDOCK" ON)

if(JAEGERTRACING_WITH_YAML_CPP)
  hunter_add_package(yaml-cpp)
  # Not `${hunter_config}` because yaml-cpp provides its own
  # yaml-cpp-config.cmake file
  find_package(yaml-cpp CONFIG REQUIRED)
  if(HUNTER_ENABLED)
      list(APPEND LIBS yaml-cpp::yaml-cpp)
  else()
      list(APPEND LIBS yaml-cpp)
  endif()
  list(APPEND package_deps yaml-cpp)
endif()

include(CTest)
if(BUILD_TESTING)
  hunter_add_package(GTest)
  find_package(GTest ${hunter_config} REQUIRED)

  if(JAEGERTRACING_COVERAGE)
      include(CodeCoverage)
      append_coverage_compiler_flags(cxx_flags)
      append_coverage_compiler_flags(link_flags)
      set(COVERAGE_EXCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/src/jaegertracing/thrift-gen/*"
                            "*Test.cpp")
  endif()
endif()

set(SRC
    src/jaegertracing/Config.cpp
    src/jaegertracing/DynamicLoad.cpp
    src/jaegertracing/LogRecord.cpp
    src/jaegertracing/Logging.cpp
    src/jaegertracing/Reference.cpp
    src/jaegertracing/Span.cpp
    src/jaegertracing/SpanContext.cpp
    src/jaegertracing/Tag.cpp
    src/jaegertracing/TraceID.cpp
    src/jaegertracing/Tracer.cpp
    src/jaegertracing/TracerFactory.cpp
    src/jaegertracing/Sender.cpp
    src/jaegertracing/ThriftSender.cpp
    src/jaegertracing/baggage/BaggageSetter.cpp
    src/jaegertracing/baggage/RemoteRestrictionJSON.cpp
    src/jaegertracing/baggage/RemoteRestrictionManager.cpp
    src/jaegertracing/baggage/Restriction.cpp
    src/jaegertracing/baggage/RestrictionManager.cpp
    src/jaegertracing/baggage/RestrictionsConfig.cpp
    src/jaegertracing/metrics/Counter.cpp
    src/jaegertracing/metrics/Gauge.cpp
    src/jaegertracing/metrics/InMemoryStatsReporter.cpp
    src/jaegertracing/metrics/Metric.cpp
    src/jaegertracing/metrics/Metrics.cpp
    src/jaegertracing/metrics/NullCounter.cpp
    src/jaegertracing/metrics/NullGauge.cpp
    src/jaegertracing/metrics/NullStatsFactory.cpp
    src/jaegertracing/metrics/NullStatsReporter.cpp
    src/jaegertracing/metrics/NullTimer.cpp
    src/jaegertracing/metrics/StatsFactory.cpp
    src/jaegertracing/metrics/StatsFactoryImpl.cpp
    src/jaegertracing/metrics/StatsReporter.cpp
    src/jaegertracing/metrics/Timer.cpp
    src/jaegertracing/net/IPAddress.cpp
    src/jaegertracing/net/Socket.cpp
    src/jaegertracing/net/URI.cpp
    src/jaegertracing/net/http/Error.cpp
    src/jaegertracing/net/http/Header.cpp
    src/jaegertracing/net/http/Method.cpp
    src/jaegertracing/net/http/Request.cpp
    src/jaegertracing/net/http/Response.cpp
    src/jaegertracing/platform/Endian.cpp
    src/jaegertracing/platform/Hostname.cpp
    src/jaegertracing/propagation/Extractor.cpp
    src/jaegertracing/propagation/HeadersConfig.cpp
    src/jaegertracing/propagation/Injector.cpp
    src/jaegertracing/propagation/Propagator.cpp
    src/jaegertracing/propagation/JaegerPropagator.cpp
    src/jaegertracing/propagation/W3CPropagator.cpp
    src/jaegertracing/reporters/CompositeReporter.cpp
    src/jaegertracing/reporters/Config.cpp
    src/jaegertracing/reporters/InMemoryReporter.cpp
    src/jaegertracing/reporters/LoggingReporter.cpp
    src/jaegertracing/reporters/NullReporter.cpp
    src/jaegertracing/reporters/RemoteReporter.cpp
    src/jaegertracing/reporters/Reporter.cpp
    src/jaegertracing/samplers/AdaptiveSampler.cpp
    src/jaegertracing/samplers/Config.cpp
    src/jaegertracing/samplers/ConstSampler.cpp
    src/jaegertracing/samplers/GuaranteedThroughputProbabilisticSampler.cpp
    src/jaegertracing/samplers/ProbabilisticSampler.cpp
    src/jaegertracing/samplers/RateLimitingSampler.cpp
    src/jaegertracing/samplers/RemoteSamplingJSON.cpp
    src/jaegertracing/samplers/RemotelyControlledSampler.cpp
    src/jaegertracing/samplers/Sampler.cpp
    src/jaegertracing/samplers/SamplingStatus.cpp
    src/jaegertracing/thrift-gen/Agent.cpp
    src/jaegertracing/thrift-gen/AggregationValidator.cpp
    src/jaegertracing/thrift-gen/BaggageRestrictionManager.cpp
    src/jaegertracing/thrift-gen/Collector.cpp
    src/jaegertracing/thrift-gen/Dependency.cpp
    src/jaegertracing/thrift-gen/SamplingManager.cpp
    src/jaegertracing/thrift-gen/ZipkinCollector.cpp
    src/jaegertracing/thrift-gen/agent_constants.cpp
    src/jaegertracing/thrift-gen/agent_types.cpp
    src/jaegertracing/thrift-gen/aggregation_validator_constants.cpp
    src/jaegertracing/thrift-gen/aggregation_validator_types.cpp
    src/jaegertracing/thrift-gen/baggage_constants.cpp
    src/jaegertracing/thrift-gen/baggage_types.cpp
    src/jaegertracing/thrift-gen/dependency_constants.cpp
    src/jaegertracing/thrift-gen/dependency_types.cpp
    src/jaegertracing/thrift-gen/jaeger_constants.cpp
    src/jaegertracing/thrift-gen/jaeger_types.cpp
    src/jaegertracing/thrift-gen/sampling_constants.cpp
    src/jaegertracing/thrift-gen/sampling_types.cpp
    src/jaegertracing/thrift-gen/zipkincore_constants.cpp
    src/jaegertracing/thrift-gen/zipkincore_types.cpp
    src/jaegertracing/utils/ErrorUtil.cpp
    src/jaegertracing/utils/HexParsing.cpp
    src/jaegertracing/utils/EnvVariable.cpp
    src/jaegertracing/utils/RateLimiter.cpp
    src/jaegertracing/utils/UDPTransporter.cpp
    src/jaegertracing/utils/HTTPTransporter.cpp
    src/jaegertracing/utils/YAML.cpp
    src/jaegertracing/ThriftMethods.cpp)

if(JAEGERTRACING_BUILD_CROSSDOCK)
  list(APPEND SRC
    src/jaegertracing/thrift-gen/TracedService.cpp
    src/jaegertracing/thrift-gen/tracetest_constants.cpp
    src/jaegertracing/thrift-gen/tracetest_types.cpp)
endif()

function(add_lib_deps lib)
  target_include_directories(${lib} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/src>)
  target_link_libraries(${lib} PUBLIC ${link_flags} ${LIBS})
  target_compile_options(${lib} PUBLIC ${cxx_flags})
endfunction()

function(update_path_for_test atest)
  if(WIN32)
    # If dependent library is a DLL we have to add location of DLL to PATH
    set(new_path "")

    foreach(LIB OpenTracing::opentracing yaml-cpp::yaml-cpp GTest::main)
      list(APPEND new_path $<TARGET_FILE_DIR:${LIB}>)
    endforeach()
    list(APPEND new_path $ENV{PATH})
    string(REPLACE ";" "\\;" new_path "${new_path}")

    set_tests_properties(${atest} PROPERTIES ENVIRONMENT "PATH=${new_path}")
  endif()
endfunction()

option(JAEGERTRACING_PLUGIN "Build dynamic plugin" OFF)
cmake_dependent_option(BUILD_SHARED_LIBS "Build shared libraries" ON
  "NOT JAEGERTRACING_PLUGIN" OFF)

if(BUILD_SHARED_LIBS)
  add_library(jaegertracing SHARED ${SRC})
  if (WIN32)
    target_compile_definitions(jaegertracing PUBLIC YAML_CPP_DLL)
    target_link_libraries(jaegertracing PUBLIC Iphlpapi Ws2_32)
  endif()
  add_lib_deps(jaegertracing)
  set_target_properties(jaegertracing PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR})
  set(JAEGERTRACING_LIB jaegertracing)
  list(APPEND JAEGERTRACING_LIBS jaegertracing)
endif()


if(JAEGERTRACING_PLUGIN)
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/export.map
    "{ global: OpenTracingMakeTracerFactory; local: *; };")
  add_library(jaegertracing_plugin MODULE ${SRC})
  add_lib_deps(jaegertracing_plugin)
  target_link_libraries(jaegertracing_plugin PUBLIC
    -static-libgcc
    -static-libstdc++
    -Wl,--version-script=${CMAKE_CURRENT_BINARY_DIR}/export.map)
endif()

add_library(jaegertracing-static STATIC ${SRC})
if (NOT WIN32)
  #on windows, the shared library generate also a .lib file
  set_target_properties(jaegertracing-static PROPERTIES OUTPUT_NAME jaegertracing)
endif()

add_lib_deps(jaegertracing-static)
if (WIN32)
  target_link_libraries(jaegertracing-static PUBLIC Iphlpapi Ws2_32)
endif()

if(NOT JAEGERTRACING_LIB)
  set(JAEGERTRACING_LIB jaegertracing-static)
endif()
list(APPEND JAEGERTRACING_LIBS jaegertracing-static)

configure_file(
  src/jaegertracing/Constants.h.in
  src/jaegertracing/Constants.h
  @ONLY)

if(JAEGERTRACING_BUILD_EXAMPLES)
  add_executable(app examples/App.cpp)
  target_link_libraries(app PUBLIC ${JAEGERTRACING_LIB})
endif()

if(BUILD_TESTING)
  add_library(testutils
      src/jaegertracing/testutils/TUDPTransport.cpp
      src/jaegertracing/testutils/SamplingManager.cpp
      src/jaegertracing/testutils/MockAgent.cpp
      src/jaegertracing/testutils/TracerUtil.cpp)
  target_link_libraries(testutils PUBLIC ${JAEGERTRACING_LIB})

  add_executable(UnitTest
      src/jaegertracing/ConfigTest.cpp
      src/jaegertracing/ReferenceTest.cpp
      src/jaegertracing/SpanContextTest.cpp
      src/jaegertracing/SpanTest.cpp
      src/jaegertracing/TagTest.cpp
      src/jaegertracing/TraceIDTest.cpp
      src/jaegertracing/TracerFactoryTest.cpp
      src/jaegertracing/TracerTest.cpp
      src/jaegertracing/ThriftSenderTest.cpp
      src/jaegertracing/baggage/BaggageTest.cpp
      src/jaegertracing/metrics/MetricsTest.cpp
      src/jaegertracing/metrics/NullStatsFactoryTest.cpp
      src/jaegertracing/net/IPAddressTest.cpp
      src/jaegertracing/net/SocketTest.cpp
      src/jaegertracing/net/URITest.cpp
      src/jaegertracing/net/http/HeaderTest.cpp

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
VERSION = 6
PATCHLEVEL = 1
SUBLEVEL = 106
EXTRAVERSION =
NAME = Curry Ramen

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

$(if $(filter __%, $(MAKECMDGOALS)), \
	$(error targets prefixed with '__' are only for internal use))

# That's our default target when none is given on the command line
PHONY := __all
__all:

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.a targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

ifneq ($(sub_make_done),1)

# Do not use make's built-in rules and variables
# (this increases performance and avoids hard-to-debug behaviour)
MAKEFLAGS += -rR

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# Avoid interference with shell env settings
unexport GREP_OPTIONS

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
# If KBUILD_VERBOSE equals 2 then give the reason why each target is rebuilt.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands
# make-4.0 (and later) keep single letter options in the 1st word of MAKEFLAGS.

ifeq ($(filter 3.%,$(MAKE_VERSION)),)
silence:=$(findstring s,$(firstword -$(MAKEFLAGS)))
else
silence:=$(findstring s,$(filter-out --%,$(MAKEFLAGS)))
endif

ifeq ($(silence),s)
quiet=silent_
KBUILD_VERBOSE = 0
endif

export quiet Q KBUILD_VERBOSE

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/dev-tools/sparse.rst" for more details,
# including where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

export KBUILD_CHECKSRC

# Enable "clippy" (a linter) as part of the Rust compilation.
#
# Use 'make CLIPPY=1' to enable it.
ifeq ("$(origin CLIPPY)", "command line")
  KBUILD_CLIPPY := $(CLIPPY)
endif

export KBUILD_CLIPPY

# Use make M=dir or set the environment variable KBUILD_EXTMOD to specify the
# directory of external module to build. Setting M= takes precedence.
ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

# Old syntax make ... SUBDIRS=$PWD should be rejected to avoid mishaps
# (see Debian bugs #982334, #987575)
ifndef KBUILD_EXTMOD
  ifdef SUBDIRS
    $(warning =============== ERROR ==============)
    $(warning 'SUBDIRS' was removed in Linux 5.3)
    $(warning Use 'M=' or 'KBUILD_EXTMOD=' instead)
    $(warning ====================================)
    $(error .)
  endif
endif

$(if $(word 2, $(KBUILD_EXTMOD)), \
	$(error building multiple external modules is not supported))

$(foreach x, % :, $(if $(findstring $x, $(KBUILD_EXTMOD)), \
	$(error module directory path cannot contain '$x')))

# Remove trailing slashes
ifneq ($(filter %/, $(KBUILD_EXTMOD)),)
KBUILD_EXTMOD := $(shell dirname $(KBUILD_EXTMOD).)
endif

export KBUILD_EXTMOD

# Kbuild will save output files in the current working directory.
# This does not need to match to the root of the kernel source tree.
#
# For example, you can do this:
#
#  cd /dir/to/store/output/files; make -f /dir/to/kernel/source/Makefile
#
# If you want to save output files in a different location, there are
# two syntaxes to specify it.
#
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the output directory.
# export KBUILD_OUTPUT=dir/to/store/output/files/; make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# Do we want to change the working directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
# Make's built-in functions such as $(abspath ...), $(realpath ...) cannot
# expand a shell special character '~'. We use a somewhat tedious way here.
abs_objtree := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) && pwd)
$(if $(abs_objtree),, \
     $(error failed to create output directory "$(KBUILD_OUTPUT)"))

# $(realpath ...) resolves symlinks
abs_objtree := $(realpath $(abs_objtree))
else
abs_objtree := $(CURDIR)
endif # ifneq ($(KBUILD_OUTPUT),)

ifeq ($(abs_objtree),$(CURDIR))
# Suppress "Entering directory ..." unless we are changing the work directory.
MAKEFLAGS += --no-print-directory
else
need-sub-make := 1
endif

this-makefile := $(lastword $(MAKEFILE_LIST))
abs_srctree := $(realpath $(dir $(this-makefile)))

ifneq ($(words $(subst :, ,$(abs_srctree))), 1)
$(error source directory cannot contain spaces or colons)
endif

ifneq ($(abs_srctree),$(abs_objtree))
# Look for make include files relative to root of kernel src
#
# --included-dir is added for backward compatibility, but you should not rely on
# it. Please add $(srctree)/ prefix to include Makefiles in the source tree.
MAKEFLAGS += --include-dir=$(abs_srctree)
endif

ifneq ($(filter 3.%,$(MAKE_VERSION)),)
# 'MAKEFLAGS += -rR' does not immediately become effective for GNU Make 3.x
# We need to invoke sub-make to avoid implicit rules in the top Makefile.
need-sub-make := 1
# Cancel implicit rules for this Makefile.
$(this-makefile): ;
endif

export abs_srctree abs_objtree
export sub_make_done := 1

ifeq ($(need-sub-make),1)

PHONY += $(MAKECMDGOALS) __sub-make

$(filter-out $(this-makefile), $(MAKECMDGOALS)) __all: __sub-make
	@:

# Invoke a second make in the output directory, passing relevant variables
__sub-make:
	$(Q)$(MAKE) -C $(abs_objtree) -f $(abs_srctree)/Makefile $(MAKECMDGOALS)

endif # need-sub-make
endif # sub_make_done

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(need-sub-make),)

# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

ifeq ($(abs_srctree),$(abs_objtree))
        # building in the source tree
        srctree := .
	building_out_of_srctree :=
else
        ifeq ($(abs_srctree)/,$(dir $(abs_objtree)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(abs_srctree)
        endif
	building_out_of_srctree := 1
endif

ifneq ($(KBUILD_ABS_SRCTREE),)
srctree := $(abs_srctree)
endif

objtree		:= .
VPATH		:= $(srctree)

export building_out_of_srctree srctree objtree VPATH

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

version_h := include/generated/uapi/linux/version.h

clean-targets := %clean mrproper cleandocs
no-dot-config-targets := $(clean-targets) \
			 cscope gtags TAGS tags help% %docs check% coccicheck \
			 $(version_h) headers headers_% archheaders archscripts \
			 %asm-generic kernelversion %src-pkg dt_binding_check \
			 outputmakefile rustavailable rustfmt rustfmtcheck
# Installation targets should not require compiler. Unfortunately, vdso_install
# is an exception where build artifacts may be updated. This must be fixed.
no-compiler-targets := $(no-dot-config-targets) install dtbs_install \
			headers_install modules_install kernelrelease image_name
no-sync-config-targets := $(no-dot-config-targets) %install kernelrelease \
			  image_name
single-targets := %.a %.i %.rsi %.ko %.lds %.ll %.lst %.mod %.o %.s %.symtypes %/

config-build	:=
mixed-build	:=
need-config	:= 1
need-compiler	:= 1
may-sync-config	:= 1
single-build	:=

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
	ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
		need-config :=
	endif
endif

ifneq ($(filter $(no-compiler-targets), $(MAKECMDGOALS)),)
	ifeq ($(filter-out $(no-compiler-targets), $(MAKECMDGOALS)),)
		need-compiler :=
	endif
endif

ifneq ($(filter $(no-sync-config-targets), $(MAKECMDGOALS)),)
	ifeq ($(filter-out $(no-sync-config-targets), $(MAKECMDGOALS)),)
		may-sync-config :=
	endif
endif

ifneq ($(KBUILD_EXTMOD),)
	may-sync-config :=
endif

ifeq ($(KBUILD_EXTMOD),)
        ifneq ($(filter %config,$(MAKECMDGOALS)),)
		config-build := 1
                ifneq ($(words $(MAKECMDGOALS)),1)
			mixed-build := 1
                endif
        endif
endif

# We cannot build single targets and the others at the same time
ifneq ($(filter $(single-targets), $(MAKECMDGOALS)),)
	single-build := 1
	ifneq ($(filter-out $(single-targets), $(MAKECMDGOALS)),)
		mixed-build := 1
	endif
endif

# For "make -j clean all", "make -j mrproper defconfig all", etc.
ifneq ($(filter $(clean-targets),$(MAKECMDGOALS)),)
        ifneq ($(filter-out $(clean-targets),$(MAKECMDGOALS)),)
		mixed-build := 1
        endif
endif

# install and modules_install need also be processed one by one
ifneq ($(filter install,$(MAKECMDGOALS)),)
        ifneq ($(filter modules_install,$(MAKECMDGOALS)),)
		mixed-build := 1
        endif
endif

ifdef mixed-build
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.

PHONY += $(MAKECMDGOALS) __build_one_by_one

$(MAKECMDGOALS): __build_one_by_one
	@:

__build_one_by_one:
	$(Q)set -e; \
	for i in $(MAKECMDGOALS); do \
		$(MAKE) -f $(srctree)/Makefile $$i; \
	done

else # !mixed-build

include $(srctree)/scripts/Kbuild.include

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
KERNELRELEASE = $(shell cat include/config/kernel.release 2> /dev/null)
KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)

=== cpp/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

cmake_minimum_required(VERSION 3.5)
message(STATUS "Building using CMake version: ${CMAKE_VERSION}")

# Compiler id for Apple Clang is now AppleClang.
# https://www.cmake.org/cmake/help/latest/policy/CMP0025.html
cmake_policy(SET CMP0025 NEW)

# Only interpret if() arguments as variables or keywords when unquoted.
# https://www.cmake.org/cmake/help/latest/policy/CMP0054.html
cmake_policy(SET CMP0054 NEW)

# Support new if() IN_LIST operator.
# https://www.cmake.org/cmake/help/latest/policy/CMP0057.html
cmake_policy(SET CMP0057 NEW)

# Adapted from Apache Kudu: https://github.com/apache/kudu/commit/bd549e13743a51013585
# Honor visibility properties for all target types.
# https://www.cmake.org/cmake/help/latest/policy/CMP0063.html
cmake_policy(SET CMP0063 NEW)

# RPATH settings on macOS do not affect install_name.
# https://cmake.org/cmake/help/latest/policy/CMP0068.html
if(POLICY CMP0068)
  cmake_policy(SET CMP0068 NEW)
endif()

# find_package() uses <PackageName>_ROOT variables.
# https://cmake.org/cmake/help/latest/policy/CMP0074.html
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

set(ARROW_VERSION "7.0.0")

string(REGEX MATCH "^[0-9]+\\.[0-9]+\\.[0-9]+" ARROW_BASE_VERSION "${ARROW_VERSION}")

# if no build build type is specified, default to release builds
if(NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      Release
      CACHE STRING "Choose the type of build.")
endif()
string(TOLOWER ${CMAKE_BUILD_TYPE} LOWERCASE_BUILD_TYPE)
string(TOUPPER ${CMAKE_BUILD_TYPE} UPPERCASE_BUILD_TYPE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules")

# this must be included before the project() command, because of the way
# vcpkg (ab)uses CMAKE_TOOLCHAIN_FILE to inject its logic into CMake
if(ARROW_DEPENDENCY_SOURCE STREQUAL "VCPKG")
  include(Usevcpkg)
endif()

project(arrow VERSION "${ARROW_BASE_VERSION}")

set(ARROW_VERSION_MAJOR "${arrow_VERSION_MAJOR}")
set(ARROW_VERSION_MINOR "${arrow_VERSION_MINOR}")
set(ARROW_VERSION_PATCH "${arrow_VERSION_PATCH}")
if(ARROW_VERSION_MAJOR STREQUAL ""
   OR ARROW_VERSION_MINOR STREQUAL ""
   OR ARROW_VERSION_PATCH STREQUAL "")
  message(FATAL_ERROR "Failed to determine Arrow version from '${ARROW_VERSION}'")
endif()

# The SO version is also the ABI version
if(ARROW_VERSION_MAJOR STREQUAL "0")
  # Arrow 0.x.y => SO version is "x", full SO version is "x.y.0"
  set(ARROW_SO_VERSION "${ARROW_VERSION_MINOR}")
  set(ARROW_FULL_SO_VERSION "${ARROW_SO_VERSION}.${ARROW_VERSION_PATCH}.0")
else()
  # Arrow 1.x.y => SO version is "10x", full SO version is "10x.y.0"
  math(EXPR ARROW_SO_VERSION "${ARROW_VERSION_MAJOR} * 100 + ${ARROW_VERSION_MINOR}")
  set(ARROW_FULL_SO_VERSION "${ARROW_SO_VERSION}.${ARROW_VERSION_PATCH}.0")
endif()

message(STATUS "Arrow version: "
               "${ARROW_VERSION_MAJOR}.${ARROW_VERSION_MINOR}.${ARROW_VERSION_PATCH} "
               "(full: '${ARROW_VERSION}')")
message(STATUS "Arrow SO version: ${ARROW_SO_VERSION} (full: ${ARROW_FULL_SO_VERSION})")

set(ARROW_SOURCE_DIR ${PROJECT_SOURCE_DIR})
set(ARROW_BINARY_DIR ${PROJECT_BINARY_DIR})

include(CMakePackageConfigHelpers)
include(CMakeParseArguments)
include(ExternalProject)
include(FindPackageHandleStandardArgs)

include(GNUInstallDirs)

set(BUILD_SUPPORT_DIR "${CMAKE_SOURCE_DIR}/build-support")

set(ARROW_CMAKE_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
set(ARROW_DOC_DIR "share/doc/${PROJECT_NAME}")

set(ARROW_LLVM_VERSIONS
    "13.0"
    "12.0"
    "11.1"
    "11.0"
    "10"
    "9"
    "8"
    "7")
list(GET ARROW_LLVM_VERSIONS 0 ARROW_LLVM_VERSION_PRIMARY)
string(REGEX REPLACE "^([0-9]+)(\\..+)?" "\\1" ARROW_LLVM_VERSION_PRIMARY_MAJOR
                     "${ARROW_LLVM_VERSION_PRIMARY}")

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/../.env ARROW_ENV)
string(REGEX MATCH "CLANG_TOOLS=[^\n]+" ARROW_ENV_CLANG_TOOLS_VERSION "${ARROW_ENV}")
string(REGEX REPLACE "^CLANG_TOOLS=" "" ARROW_CLANG_TOOLS_VERSION
                     "${ARROW_ENV_CLANG_TOOLS_VERSION}")
string(REGEX REPLACE "^([0-9]+)(\\..+)?" "\\1" ARROW_CLANG_TOOLS_VERSION_MAJOR
                     "${ARROW_CLANG_TOOLS_VERSION}")

if(APPLE)
  find_program(BREW_BIN brew)
  if(BREW_BIN)
    execute_process(COMMAND ${BREW_BIN} --prefix
                            "llvm@${ARROW_LLVM_VERSION_PRIMARY_MAJOR}"
                    OUTPUT_VARIABLE LLVM_BREW_PREFIX
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(NOT LLVM_BREW_PREFIX)
      execute_process(COMMAND ${BREW_BIN} --prefix llvm
                      OUTPUT_VARIABLE LLVM_BREW_PREFIX
                      OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()

    execute_process(COMMAND ${BREW_BIN} --prefix "llvm@${ARROW_CLANG_TOOLS_VERSION_MAJOR}"
                    OUTPUT_VARIABLE CLANG_TOOLS_BREW_PREFIX
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(NOT CLANG_TOOLS_BREW_PREFIX)
      execute_process(COMMAND ${BREW_BIN} --prefix llvm
                      OUTPUT_VARIABLE CLANG_TOOLS_BREW_PREFIX
                      OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
  endif()
endif()

if(WIN32 AND NOT MINGW)
  # This is used to handle builds using e.g. clang in an MSVC setting.
  set(MSVC_TOOLCHAIN TRUE)
else()
  set(MSVC_TOOLCHAIN FALSE)
endif()

find_package(ClangTools)
find_package(InferTools)
if("$ENV{CMAKE_EXPORT_COMPILE_COMMANDS}" STREQUAL "1"
   OR CLANG_TIDY_FOUND
   OR INFER_FOUND)
  # Generate a Clang compile_commands.json "compilation database" file for use
  # with various development tools, such as Vim's YouCompleteMe plugin.
  # See http://clang.llvm.org/docs/JSONCompilationDatabase.html
  set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
endif()

# ----------------------------------------------------------------------
# cmake options
include(DefineOptions)

# Needed for linting targets, etc.
if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
  find_package(PythonInterp)
else()
  # Use the first Python installation on PATH, not the newest one
  set(Python3_FIND_STRATEGY "LOCATION")
  # On Windows, use registry last, not first
  set(Python3_FIND_REGISTRY "LAST")
  # On macOS, use framework last, not first
  set(Python3_FIND_FRAMEWORK "LAST")

  find_package(Python3)
  set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
endif()

if(ARROW_USE_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(CCACHE_FOUND)
    message(STATUS "Using ccache: ${CCACHE_FOUND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_FOUND})
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE_FOUND})
    # ARROW-3985: let ccache preserve C++ comments, because some of them may be
    # meaningful to the compiler
    set(ENV{CCACHE_COMMENTS} "1")
  endif(CCACHE_FOUND)
endif()

if(ARROW_USE_PRECOMPILED_HEADERS AND ${CMAKE_VERSION} VERSION_LESS "3.16.0")
  message(WARNING "Precompiled headers need CMake 3.16.0 or later, disabling")
  set(ARROW_USE_PRECOMPILED_HEADERS OFF)
endif()

if(ARROW_OPTIONAL_INSTALL)
  # Don't make the "install" target depend on the "all" target
  set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY true)

  set(INSTALL_IS_OPTIONAL OPTIONAL)
endif()

#
# "make lint" target
#
if(NOT ARROW_VERBOSE_LINT)
  set(ARROW_LINT_QUIET "--quiet")
endif()

if(NOT LINT_EXCLUSIONS_FILE)
  # source files matching a glob from a line in this file
  # will be excluded from linting (cpplint, clang-tidy, clang-format)
  set(LINT_EXCLUSIONS_FILE ${BUILD_SUPPORT_DIR}/lint_exclusions.txt)
endif()

find_program(CPPLINT_BIN
             NAMES cpplint cpplint.py
             HINTS ${BUILD_SUPPORT_DIR})
message(STATUS "Found cpplint executable at ${CPPLINT_BIN}")

set(COMMON_LINT_OPTIONS
    --exclude_globs
    ${LINT_EXCLUSIONS_FILE}
    --source_dir
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    --source_dir
    ${CMAKE_CURRENT_SOURCE_DIR}/examples
    --source_dir
    ${CMAKE_CURRENT_SOURCE_DIR}/tools)

add_custom_target(lint
                  ${PYTHON_EXECUTABLE}
                  ${BUILD_SUPPORT_DIR}/run_cpplint.py
                  --cpplint_binary
                  ${CPPLINT_BIN}
                  ${COMMON_LINT_OPTIONS}
                  ${ARROW_LINT_QUIET})

#
# "make format" and "make check-format" targets
#
if(${CLANG_FORMAT_FOUND})
  # runs clang format and updates files in place.
  add_custom_target(format
                    ${PYTHON_EXECUTABLE}
                    ${BUILD_SUPPORT_DIR}/run_clang_format.py
                    --clang_format_binary
                    ${CLANG_FORMAT_BIN}
                    ${COMMON_LINT_OPTIONS}
                    --fix
                    ${ARROW_LINT_QUIET})

  # runs clang format and exits with a non-zero exit code if any files need to be reformatted
  add_custom_target(check-format
                    ${PYTHON_EXECUTABLE}
                    ${BUILD_SUPPORT_DIR}/run_clang_format.py
                    --clang_format_binary
                    ${CLANG_FORMAT_BIN}
                    ${COMMON_LINT_OPTIONS}
                    ${ARROW_LINT_QUIET})
endif()

add_custom_target(lint_cpp_cli ${PYTHON_EXECUTABLE} ${BUILD_SUPPORT_DIR}/lint_cpp_cli.py
                               ${CMAKE_CURRENT_SOURCE_DIR}/src)

if(ARROW_LINT_ONLY)
  message("ARROW_LINT_ONLY was specified, this is only a partial build directory")
  return()
endif()

#
# "make clang-tidy" and "make check-clang-tidy" targets
#
if(${CLANG_TIDY_FOUND})
  # TODO check to make sure .clang-tidy is being respected

  # runs clang-tidy and attempts to fix any warning automatically
  add_custom_target(clang-tidy
                    ${PYTHON_EXECUTABLE}
                    ${BUILD_SUPPORT_DIR}/run_clang_tidy.py
                    --clang_tidy_binary
                    ${CLANG_TIDY_BIN}
                    --compile_commands
                    ${CMAKE_BINARY_DIR}/compile_commands.json
                    ${COMMON_LINT_OPTIONS}
                    --fix
                    ${ARROW_LINT_QUIET})

  # runs clang-tidy and exits with a non-zero exit code if any errors are found.
  add_custom_target(check-clang-tidy
                    ${PYTHON_EXECUTABLE}
                    ${BUILD_SUPPORT_DIR}/run_clang_tidy.py
                    --clang_tidy_binary
                    ${CLANG_TIDY_BIN}
                    --compile_commands
                    ${CMAKE_BINARY_DIR}/compile_commands.json
                    ${COMMON_LINT_OPTIONS}
                    ${ARROW_LINT_QUIET})
endif()

if(UNIX)
  add_custom_target(iwyu ${BUILD_SUPPORT_DIR}/iwyu/iwyu.sh)
  add_custom_target(iwyu-all ${BUILD_SUPPORT_DIR}/iwyu/iwyu.sh all)
endif(UNIX)

#
# Set up various options
#

if(ARROW_BUILD_BENCHMARKS
   OR ARROW_BUILD_TESTS
   OR ARROW_BUILD_INTEGRATION
   OR ARROW_FUZZING)
  set(ARROW_JSON ON)
  set(ARROW_TESTING ON)
endif()

if(ARROW_GANDIVA)
  set(ARROW_WITH_RE2 ON)
endif()

if(ARROW_BUILD_INTEGRATION AND ARROW_FLIGHT)
  set(ARROW_FLIGHT_SQL ON)
endif()

if(ARROW_FLIGHT_SQL)
  set(ARROW_FLIGHT ON)
endif()

if(ARROW_CUDA
   OR ARROW_FLIGHT
   OR ARROW_PARQUET
   OR ARROW_BUILD_TESTS
   OR ARROW_BUILD_BENCHMARKS)
  set(ARROW_IPC ON)
endif()

if(ARROW_ENGINE)
  set(ARROW_COMPUTE ON)
endif()

if(ARROW_SKYHOOK)
  set(ARROW_DATASET ON)
  set(ARROW_PARQUET ON)
  set(ARROW_WITH_LZ4 ON)
  set(ARROW_WITH_SNAPPY ON)
endif()

if(ARROW_DATASET)
  set(ARROW_COMPUTE ON)
  set(ARROW_FILESYSTEM ON)
endif()

=== docker/Makefile ===
VERSION := 1.0.0
ROOT_IMAGE ?= alpine:3.16
CERT_IMAGE := $(ROOT_IMAGE)
GOLANG_IMAGE := golang:1.22-alpine

DOCKER_REGISTRY ?= localhost:5000
BASE_IMAGE ?= $(DOCKER_REGISTRY)/baseimg_alpine:latest
DEBUG_IMAGE ?= $(DOCKER_REGISTRY)/debugimg_alpine:latest
PLATFORMS ?= linux/amd64,linux/s390x,linux/ppc64le,linux/arm64

create-baseimg-debugimg: create-baseimg create-debugimg

create-baseimg: prepare-docker-buildx
	docker buildx build -t $(BASE_IMAGE) --push \
		--build-arg root_image=$(ROOT_IMAGE) \
		--build-arg cert_image=$(CERT_IMAGE) \
		--platform=$(PLATFORMS) \
		docker/base

create-debugimg: prepare-docker-buildx
	docker buildx build -t $(DEBUG_IMAGE) --push \
		--build-arg golang_image=$(GOLANG_IMAGE) \
		--platform=$(PLATFORMS) \
		docker/debug

.PHONY: prepare-docker-buildx
prepare-docker-buildx:
	docker buildx inspect jaeger-build > /dev/null || docker buildx create --use --name=jaeger-build --buildkitd-flags="--allow-insecure-entitlement security.insecure --allow-insecure-entitlement network.host" --driver-opt="network=host"
	docker inspect registry > /dev/null || docker run --rm -d -p 5000:5000 --name registry registry:2

.PHONY: clean-docker-buildx
clean-docker-buildx:
	docker buildx rm jaeger-build
	docker rm -f registry

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

set(EXAMPLES
    capitalize
    condense
    filterkey
    filterkeydom
    jsonx
    messagereader
    parsebyparts
    pretty
    prettyauto
    schemavalidator
    serialize
    simpledom
    simplereader
    simplewriter
    tutorial)
    
include_directories("../include/")

add_definitions(-D__STDC_FORMAT_MACROS)

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -Werror -Wall -Wextra -Weffc++ -Wswitch-default")
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Wall -Wextra -Weffc++ -Wswitch-default -Wfloat-equal -Wimplicit-fallthrough -Weverything")
endif()

if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=type-limits")
endif()

foreach (example ${EXAMPLES})
    add_executable(${example} ${example}/${example}.cpp)
endforeach()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_link_libraries(parsebyparts pthread)
endif()

add_custom_target(examples ALL DEPENDS ${EXAMPLES})

=== examples/CMakeLists.txt ===
set(INCLUDES ${CASS_INCLUDE_DIR})

file(GLOB_RECURSE EXAMPLES_TO_BUILD "*/CMakeLists.txt")

#------------------------------
# Compiler flags
#------------------------------

if(CASS_USE_STATIC_LIBS)
  add_definitions(-DCASS_STATIC)
endif()

#------------------------
# Subdirectories
#------------------------

list(APPEND INCLUDES ${CASS_INCLUDES})

foreach(example ${EXAMPLES_TO_BUILD})
  get_filename_component(exdir ${example} PATH)
  add_subdirectory(${exdir})
endforeach()

=== src/CMakeLists.txt ===
include(CheckSymbolExists)
include(CheckCXXSourceCompiles)

file(GLOB SOURCES *.cpp *.hpp)

if(APPLE)
  list(REMOVE_ITEM SOURCES ${CASS_SRC_DIR}/get_time-unix.cpp ${CASS_SRC_DIR}/get_time-win.cpp)
elseif(UNIX)
  list(REMOVE_ITEM SOURCES ${CASS_SRC_DIR}/get_time-mac.cpp ${CASS_SRC_DIR}/get_time-win.cpp)
elseif(WIN32)
  list(REMOVE_ITEM SOURCES ${CASS_SRC_DIR}/get_time-mac.cpp ${CASS_SRC_DIR}/get_time-unix.cpp)
endif()

if(CASS_USE_OPENSSL)
  list(APPEND SOURCES ssl/ssl_openssl_impl.cpp ssl/ring_buffer_bio.cpp)
else()
  list(APPEND SOURCES ssl/ssl_no_impl.cpp)
endif()

if(CASS_USE_KERBEROS)
  list(APPEND INCLUDE_DIRS gssapi)
  list(APPEND SOURCES gssapi/dse_auth_gssapi.cpp gssapi/dse_auth_gssapi.hpp)
endif()

# Determine atomic library to include
if(CASS_USE_BOOST_ATOMIC)
  list(APPEND SOURCES atomic/atomic_boost.hpp)
elseif(CASS_USE_STD_ATOMIC)
  list(APPEND SOURCES atomic/atomic_std.hpp)
else()
  list(APPEND SOURCES atomic/atomic_intrinsics.hpp)
  if(WIN32)
    list(APPEND SOURCES atomic/atomic_intrinsics_msvc.hpp)
  else()
    list(APPEND SOURCES atomic/atomic_intrinsics_gcc.hpp)
  endif()
endif()

add_subdirectory(third_party/curl)
add_subdirectory(third_party/hdr_histogram)
add_subdirectory(third_party/http-parser)
add_subdirectory(third_party/minizip)
add_subdirectory(third_party/sparsehash)

list(APPEND INCLUDE_DIRS 
  third_party/curl
  third_party/hdr_histogram
  third_party/http-parser
  third_party/minizip
  third_party/mt19937_64
  third_party/rapidjson/rapidjson
  third_party/sparsehash/src)

list(APPEND INCLUDE_DIRS ${CASS_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

#------------------------------
# Compiler flags
#------------------------------

# Ensure Windows platform is supported
if(WIN32)
  if(CMAKE_SYSTEM_VERSION GREATER 5.2 OR
      CMAKE_SYSTEM_VERSION EQUAL 5.2)
    add_definitions(-D_WIN32_WINNT=0x502)
  else()
    string(REPLACE "." "" WINDOWS_VERSION ${CMAKE_SYSTEM_VERSION})
    string(REGEX REPLACE "([0-9])" "0\\1" WINDOWS_VERSION ${WINDOWS_VERSION})
    message(FATAL_ERROR "Unable to build driver: Unsupported Windows platform 0x${WINDOWS_VERSION}")
  endif()
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wconversion -Wno-sign-conversion -Wno-shorten-64-to-32 -Wno-undefined-var-template -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-implicit-int-float-conversion")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") # To many superfluous warnings generated with GCC when using -Wconversion (see: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=40752)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

#------------------------------
# Build configured header
#------------------------------

# Determine random availability
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  check_symbol_exists(GRND_NONBLOCK "linux/random.h" HAVE_GETRANDOM)
  if(CASS_USE_TIMERFD)
    check_symbol_exists(timerfd_create "sys/timerfd.h" HAVE_TIMERFD)
  endif()
else()
  check_symbol_exists(arc4random_buf "stdlib.h" HAVE_ARC4RANDOM)
endif()

# Determine if sigpipe is available
check_symbol_exists(SO_NOSIGPIPE "sys/socket.h;sys/types.h" HAVE_NOSIGPIPE)
check_symbol_exists(sigtimedwait "signal.h" HAVE_SIGTIMEDWAIT)
if (NOT WIN32 AND NOT HAVE_NOSIGPIPE AND NOT HAVE_SIGTIMEDWAIT)
  message(WARNING "Unable to handle SIGPIPE on your platform")
endif()

# Determine if hash is in the tr1 namespace
string(REPLACE "::" ";" HASH_NAMESPACE_LIST ${HASH_NAMESPACE})
foreach(NAMESPACE ${HASH_NAMESPACE_LIST})
  if(NAMESPACE STREQUAL "tr1")
    set(HASH_IN_TR1 1)
  endif()
endforeach()

# Check for GCC compiler builtins
if(NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  check_cxx_source_compiles("int main() { return __builtin_bswap32(42); }" HAVE_BUILTIN_BSWAP32)
  check_cxx_source_compiles("int main() { return __builtin_bswap64(42); }" HAVE_BUILTIN_BSWAP64)
endif()

set(HAVE_BOOST_ATOMIC ${CASS_USE_BOOST_ATOMIC})
set(HAVE_STD_ATOMIC ${CASS_USE_STD_ATOMIC})
set(HAVE_KERBEROS ${CASS_USE_KERBEROS})
set(HAVE_OPENSSL ${CASS_USE_OPENSSL})
set(HAVE_ZLIB ${CASS_USE_ZLIB})

# Generate the driver_config.hpp file
configure_file(
  ${CASS_ROOT_DIR}/driver_config.hpp.in 
  ${CMAKE_CURRENT_SOURCE_DIR}/driver_config.hpp)


#------------------------------
# Targets
#------------------------------

if(CASS_BUILD_SHARED)
  add_library(cassandra SHARED 
    ${SOURCES}
    $<TARGET_OBJECTS:curl_hostcheck>
    $<TARGET_OBJECTS:hdr_histogram>
    $<TARGET_OBJECTS:http-parser>
    $<TARGET_OBJECTS:minizip>)
  target_link_libraries(cassandra ${CASS_LIBS})
  target_include_directories(cassandra PRIVATE ${INCLUDE_DIRS} ${CASS_INCLUDES})

  set_target_properties(cassandra PROPERTIES OUTPUT_NAME cassandra)
  set_target_properties(cassandra PROPERTIES VERSION ${PROJECT_VERSION_STRING} SOVERSION ${PROJECT_VERSION_MAJOR})
  set_target_properties(cassandra PROPERTIES
      COMPILE_PDB_NAME "cassandra"
      COMPILE_PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  set_target_properties(cassandra PROPERTIES
      ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
      LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
      RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
  set_target_properties(cassandra PROPERTIES FOLDER "Driver")

  target_compile_definitions(cassandra PRIVATE CASS_BUILDING)

  if(CASS_USE_BOOST_ATOMIC AND BOOST_LIBRARY_NAME)
    add_dependencies(cassandra ${BOOST_LIBRARY_NAME})
  endif()
  if(LIBUV_LIBRARY_NAME)
    add_dependencies(cassandra ${LIBUV_LIBRARY_NAME})
  endif()
  if(OPENSSL_LIBRARY_NAME)
    add_dependencies(cassandra ${OPENSSL_LIBRARY_NAME})
  endif()
  if(ZLIB_LIBRARY_NAME)
    add_dependencies(cassandra ${ZLIB_LIBRARY_NAME})
  endif()
endif()

if(CASS_BUILD_STATIC)
  add_library(cassandra_static STATIC
    ${SOURCES}
    $<TARGET_OBJECTS:curl_hostcheck_static>
    $<TARGET_OBJECTS:hdr_histogram_static>
    $<TARGET_OBJECTS:http-parser_static>
    $<TARGET_OBJECTS:minizip_static>)
  target_link_libraries(cassandra_static ${CASS_LIBS})
  target_include_directories(cassandra_static PRIVATE ${INCLUDE_DIRS} ${CASS_INCLUDES})

  set_target_properties(cassandra_static PROPERTIES OUTPUT_NAME cassandra_static)
  set_target_properties(cassandra_static PROPERTIES VERSION ${PROJECT_VERSION_STRING} SOVERSION ${PROJECT_VERSION_MAJOR})
  set_target_properties(cassandra_static PROPERTIES
      COMPILE_PDB_NAME "cassandra_static"
      COMPILE_PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  set_target_properties(cassandra_static PROPERTIES
      ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
      LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
      RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
  set_target_properties(cassandra_static PROPERTIES FOLDER "Driver")

  target_compile_definitions(cassandra_static PRIVATE CASS_STATIC)

  if(CASS_USE_BOOST_ATOMIC AND BOOST_LIBRARY_NAME)
    add_dependencies(cassandra_static ${BOOST_LIBRARY_NAME})
  endif()
  if(LIBUV_LIBRARY_NAME)
    add_dependencies(cassandra_static ${LIBUV_LIBRARY_NAME})
  endif()
  if(OPENSSL_LIBRARY_NAME)
    add_dependencies(cassandra_static ${OPENSSL_LIBRARY_NAME})
  endif()
  if(ZLIB_LIBRARY_NAME)
    add_dependencies(cassandra_static ${ZLIB_LIBRARY_NAME})
  endif()
endif()

#-------------------------------------
# Installation
#-------------------------------------

# Determine if the library directory needs to be determined
if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
  if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux" AND ("${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr" OR
    "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local"))
    if(EXISTS "/etc/debian_version")
      set (CMAKE_INSTALL_LIBDIR "lib/${CMAKE_LIBRARY_ARCHITECTURE}")
    elseif(EXISTS "/etc/redhat-release" OR EXISTS "/etc/fedora-release" OR
        EXISTS "/etc/slackware-version" OR EXISTS "/etc/gentoo-release")
      if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set (CMAKE_INSTALL_LIBDIR "lib64")
      else()
        set (CMAKE_INSTALL_LIBDIR "lib")
      endif()
    else()
      set (CMAKE_INSTALL_LIBDIR "lib")
    endif()
  else()
    set (CMAKE_INSTALL_LIBDIR "lib")
  endif()
endif()

# Create a binary directory executable and DLLs (windows only)
set(INSTALL_DLL_EXE_DIR "bin") # Determine the header install dir
if (CASS_INSTALL_HEADER_IN_SUBDIR)
  if (CASS_INSTALL_HEADER_SUBDIR_NAME)
    # User-specified include sub-dir
    set(INSTALL_HEADER_DIR "include/${CASS_INSTALL_HEADER_SUBDIR_NAME}")
  else()
    # Default subdir location is 'include/cassandra'
    set(INSTALL_HEADER_DIR "include/cassandra")
  endif()
else()
  # Default header install location is 'include'
  set(INSTALL_HEADER_DIR "include")
endif()

if(CASS_INSTALL_PKG_CONFIG)
  if(NOT WIN32)
    find_package(PkgConfig)
    if(PKG_CONFIG_FOUND)
      set(prefix ${CMAKE_INSTALL_PREFIX})
      set(exec_prefix ${CMAKE_INSTALL_PREFIX})
      set(libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
      set(includedir ${CMAKE_INSTALL_PREFIX}/${INSTALL_HEADER_DIR})
      set(version ${PROJECT_VERSION_STRING})
    endif()
  endif()
endif()

# Determine if the header should be installed
if(CASS_INSTALL_HEADER)
  file(GLOB CASS_API_HEADER_FILES ${CASS_INCLUDE_DIR}/*.h)
  install(FILES ${CASS_API_HEADER_FILES} DESTINATION ${INSTALL_HEADER_DIR})
endif()

# Install the dynamic/shared library
if(CASS_BUILD_SHARED)
  install(TARGETS cassandra
    RUNTIME DESTINATION ${INSTALL_DLL_EXE_DIR}  # for dll/executable/pdb files
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}  # for shared library
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}) # for static library
  if(CASS_INSTALL_PKG_CONFIG)
    if(NOT WIN32)
      if(PKG_CONFIG_FOUND)
        configure_file("${PROJECT_SOURCE_DIR}/packaging/cassandra.pc.in" "cassandra.pc" @ONLY)
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cassandra.pc"
          DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
      endif()
    endif()
  endif()
  if(WIN32)
    install(FILES $<TARGET_PDB_FILE:cassandra>
      DESTINATION "${INSTALL_DLL_EXE_DIR}"
      OPTIONAL)
  endif()
endif()

if(CASS_BUILD_STATIC)
  install(TARGETS cassandra_static
    RUNTIME DESTINATION ${INSTALL_DLL_EXE_DIR}  # for dll/executable/pdb files
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}  # for shared library
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}) # for static library
  if(CASS_INSTALL_PKG_CONFIG)
    if(NOT WIN32)
      if(PKG_CONFIG_FOUND)
        configure_file("${PROJECT_SOURCE_DIR}/packaging/cassandra_static.pc.in" "cassandra_static.pc" @ONLY)
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cassandra_static.pc"
          DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
      endif()
    endif()
  endif()
endif()

#-------------------
# Uninstall target
#-------------------

configure_file(
  "${CASS_ROOT_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

# FIXME
# Determine if all GNU extensions should be enabled
#if("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
#  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
#endif()

=== test/CMakeLists.txt ===
find_package(GTestSrc)

if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=type-limits")
endif()

IF(GTESTSRC_FOUND)
    enable_testing()

    if (WIN32 AND (NOT CYGWIN) AND (NOT MINGW))
        set(gtest_disable_pthreads ON)
        set(gtest_force_shared_crt ON)
    endif()

    add_subdirectory(${GTEST_SOURCE_DIR} ${CMAKE_BINARY_DIR}/googletest)
    include_directories(SYSTEM ${GTEST_INCLUDE_DIR})

    set(TEST_LIBRARIES gtest gtest_main)

    add_custom_target(tests ALL)
    add_subdirectory(perftest)
    add_subdirectory(unittest)

ENDIF(GTESTSRC_FOUND)

=== arch/sh/Makefile ===
#
# arch/sh/Makefile
#
# Copyright (C) 1999  Kaz Kojima
# Copyright (C) 2002 - 2008  Paul Mundt
# Copyright (C) 2002  M. R. Brown
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file "COPYING" in the main directory of this archive
# for more details.
#
ifdef cross_compiling
  ifeq ($(CROSS_COMPILE),)
    CROSS_COMPILE := $(call cc-cross-prefix, sh-linux- sh-linux-gnu- sh-unknown-linux-gnu-)
  endif
endif

KBUILD_DEFCONFIG	:= shx3_defconfig

isa-y					:= any
isa-$(CONFIG_SH_DSP)			:= sh
isa-$(CONFIG_CPU_SH2)			:= sh2
isa-$(CONFIG_CPU_SH2A)			:= sh2a
isa-$(CONFIG_CPU_SH3)			:= sh3
isa-$(CONFIG_CPU_SH4)			:= sh4
isa-$(CONFIG_CPU_SH4A)			:= sh4a
isa-$(CONFIG_CPU_SH4AL_DSP)		:= sh4al

isa-$(CONFIG_SH_DSP)			:= $(isa-y)-dsp
isa-y					:= $(isa-y)-up

cflags-$(CONFIG_CPU_SH2)		:= $(call cc-option,-m2,)
cflags-$(CONFIG_CPU_J2)			+= $(call cc-option,-mj2,)
cflags-$(CONFIG_CPU_SH2A)		+= $(call cc-option,-m2a,) \
					   $(call cc-option,-m2a-nofpu,) \
					   $(call cc-option,-m4-nofpu,)
cflags-$(CONFIG_CPU_SH3)		:= $(call cc-option,-m3,)
cflags-$(CONFIG_CPU_SH4)		:= $(call cc-option,-m4,) \
	$(call cc-option,-mno-implicit-fp,-m4-nofpu)
cflags-$(CONFIG_CPU_SH4A)		+= $(call cc-option,-m4a,) \
					   $(call cc-option,-m4a-nofpu,)
cflags-$(CONFIG_CPU_SH4AL_DSP)		+= $(call cc-option,-m4al,)

ifeq ($(cflags-y),)
#
# In the case where we are stuck with a compiler that has been uselessly
# restricted to a particular ISA, a favourite default of newer GCCs when
# extensive multilib targets are not provided, ensure we get the best fit
# regarding FP generation. This is intentionally stupid (albeit many
# orders of magnitude less than GCC's default behaviour), as anything
# with a large number of multilib targets better have been built
# correctly for the target in mind.
#
cflags-y	+= $(shell $(CC) $(KBUILD_CFLAGS) -print-multi-lib | \
		     grep nofpu | sed q | sed -e 's/^/-/;s/;.*$$//')
# At this point, anything goes.
isaflags-y	:= $(call as-option,-Wa$(comma)-isa=any,)
else
#
# -Wa,-isa= tuning implies -Wa,-dsp for the versions of binutils that
# support it, while -Wa,-dsp by itself limits the range of usable opcodes
# on certain CPU subtypes. Try the ISA variant first, and if that fails,
# fall back on -Wa,-dsp for the old binutils versions. Even without DSP
# opcodes, we always want the best ISA tuning the version of binutils
# will provide.
#
isaflags-y	:= $(call as-option,-Wa$(comma)-isa=$(isa-y),)

isaflags-$(CONFIG_SH_DSP)		:= \
	$(call as-option,-Wa$(comma)-isa=$(isa-y),-Wa$(comma)-dsp)
endif

cflags-$(CONFIG_CPU_BIG_ENDIAN)		+= -mb
cflags-$(CONFIG_CPU_LITTLE_ENDIAN)	+= -ml

cflags-y	+= $(call cc-option,-mno-fdpic)
cflags-y	+= $(isaflags-y) -ffreestanding

OBJCOPYFLAGS	:= -O binary -R .note -R .note.gnu.build-id -R .comment \
		   -R .stab -R .stabstr -S

# Give the various platforms the opportunity to set default image types
defaultimage-y					:= zImage
defaultimage-$(CONFIG_SH_RSK)			:= uImage
defaultimage-$(CONFIG_SH_URQUELL)		:= uImage
defaultimage-$(CONFIG_SH_MIGOR)			:= uImage
defaultimage-$(CONFIG_SH_AP325RXA)		:= uImage
defaultimage-$(CONFIG_SH_SH7757LCR)		:= uImage
defaultimage-$(CONFIG_SH_7724_SOLUTION_ENGINE)	:= uImage
defaultimage-$(CONFIG_SH_7206_SOLUTION_ENGINE)	:= vmlinux
defaultimage-$(CONFIG_SH_7619_SOLUTION_ENGINE)	:= vmlinux

# Set some sensible Kbuild defaults
boot := arch/sh/boot
KBUILD_IMAGE		:= $(boot)/$(defaultimage-y)

#
# Choosing incompatible machines durings configuration will result in
# error messages during linking.
#
UTS_MACHINE		:= sh
LDFLAGS_vmlinux		+= -e _stext

ifdef CONFIG_CPU_LITTLE_ENDIAN
ld_bfd			:= elf32-sh-linux
LDFLAGS_vmlinux		+= --defsym jiffies=jiffies_64 --oformat $(ld_bfd)
KBUILD_LDFLAGS		+= -EL
else
ld_bfd			:= elf32-shbig-linux
LDFLAGS_vmlinux		+= --defsym jiffies=jiffies_64+4 --oformat $(ld_bfd)
KBUILD_LDFLAGS		+= -EB
endif

export ld_bfd

# Mach groups
machdir-$(CONFIG_SOLUTION_ENGINE)		+= mach-se
machdir-$(CONFIG_SH_HP6XX)			+= mach-hp6xx
machdir-$(CONFIG_SH_DREAMCAST)			+= mach-dreamcast
machdir-$(CONFIG_SH_SH03)			+= mach-sh03
machdir-$(CONFIG_SH_RTS7751R2D)			+= mach-r2d
machdir-$(CONFIG_SH_HIGHLANDER)			+= mach-highlander
machdir-$(CONFIG_SH_MIGOR)			+= mach-migor
machdir-$(CONFIG_SH_AP325RXA)			+= mach-ap325rxa
machdir-$(CONFIG_SH_KFR2R09)			+= mach-kfr2r09
machdir-$(CONFIG_SH_ECOVEC)			+= mach-ecovec24
machdir-$(CONFIG_SH_SDK7780)			+= mach-sdk7780
machdir-$(CONFIG_SH_SDK7786)			+= mach-sdk7786
machdir-$(CONFIG_SH_X3PROTO)			+= mach-x3proto
machdir-$(CONFIG_SH_SH7763RDP)			+= mach-sh7763rdp
machdir-$(CONFIG_SH_SH4202_MICRODEV)		+= mach-microdev
machdir-$(CONFIG_SH_LANDISK)			+= mach-landisk
machdir-$(CONFIG_SH_LBOX_RE2)			+= mach-lboxre2
machdir-$(CONFIG_SH_RSK)			+= mach-rsk

ifneq ($(machdir-y),)
core-y	+= $(addprefix arch/sh/boards/, \
	     $(filter-out ., $(patsubst %,%/,$(machdir-y))))
endif

# Common machine type headers. Not part of the arch/sh/boards/ hierarchy.
machdir-y	+= mach-common

# Companion chips
core-$(CONFIG_HD6446X_SERIES)	+= arch/sh/cchips/hd6446x/

#
# CPU header paths
#
# These are ordered by optimization level. A CPU family that is a subset
# of another (ie, SH-2A / SH-2), is picked up first, with increasing
# levels of genericness if nothing more suitable is situated in the
# hierarchy.
#
# As an example, in order of preference, SH-2A > SH-2 > common definitions.
#
cpuincdir-$(CONFIG_CPU_SH2A)	+= cpu-sh2a
cpuincdir-$(CONFIG_CPU_SH2)	+= cpu-sh2
cpuincdir-$(CONFIG_CPU_SH3)	+= cpu-sh3
cpuincdir-$(CONFIG_CPU_SH4A)	+= cpu-sh4a
cpuincdir-$(CONFIG_CPU_SH4)	+= cpu-sh4
cpuincdir-y			+= cpu-common	# Must be last

drivers-y			+= arch/sh/drivers/

cflags-y	+= $(foreach d, $(cpuincdir-y), -I $(srctree)/arch/sh/include/$(d)) \
		   $(foreach d, $(machdir-y), -I $(srctree)/arch/sh/include/$(d))

KBUILD_CFLAGS		+= -pipe $(cflags-y)
KBUILD_CPPFLAGS		+= $(cflags-y)
KBUILD_AFLAGS		+= $(cflags-y)

ifeq ($(CONFIG_MCOUNT),y)
  KBUILD_CFLAGS += -pg
endif

ifeq ($(CONFIG_DWARF_UNWINDER),y)
  KBUILD_CFLAGS += -fasynchronous-unwind-tables
endif

libs-y			:= arch/sh/lib/	$(libs-y)

BOOT_TARGETS = uImage uImage.bz2 uImage.gz uImage.lzma uImage.xz uImage.lzo \
	       uImage.srec uImage.bin zImage vmlinux.bin vmlinux.srec \
	       romImage
PHONY += $(BOOT_TARGETS)

all: $(notdir $(KBUILD_IMAGE))

$(BOOT_TARGETS): vmlinux
	$(Q)$(MAKE) $(build)=$(boot) $(boot)/$@

compressed: zImage

archprepare:
	$(Q)$(MAKE) $(build)=arch/sh/tools include/generated/machtypes.h

archheaders:
	$(Q)$(MAKE) $(build)=arch/sh/kernel/syscalls all

define archhelp
	@echo '  zImage 	           - Compressed kernel image'
	@echo '  romImage	           - Compressed ROM image, if supported'
	@echo '  vmlinux.srec	           - Create an ELF S-record'
	@echo '  vmlinux.bin	           - Create an uncompressed binary image'
	@echo '* uImage  	           - Alias to bootable U-Boot image'
	@echo '  uImage.srec	           - Create an S-record for U-Boot'
	@echo '  uImage.bin	           - Kernel-only image for U-Boot (bin)'
	@echo '* uImage.gz	           - Kernel-only image for U-Boot (gzip)'
	@echo '  uImage.bz2	           - Kernel-only image for U-Boot (bzip2)'
	@echo '  uImage.lzma	           - Kernel-only image for U-Boot (lzma)'
	@echo '  uImage.xz	           - Kernel-only image for U-Boot (xz)'
	@echo '  uImage.lzo	           - Kernel-only image for U-Boot (lzo)'
endef

=== docker-compose/monitor/Makefile ===
.PHONY: build
build: export DOCKER_TAG = dev
build: clean-jaeger
	cd ../../ && \
	make build-all-in-one-linux && \
	make docker-images-jaeger-backend

# starts up the system required for SPM using the latest otel image and a development jaeger image.
# Note: the jaeger "dev" image can be built with "make build".
.PHONY: dev
dev: export JAEGER_IMAGE_TAG = dev
dev:
	docker compose -f docker-compose.yml up

# starts older spanmetrics processor setup, for example,
# to test backwards compatibility of Jaeger with spanmetrics processor.
.PHONY: dev-processor
dev-processor: export JAEGER_IMAGE_TAG = dev
# Fix to a version before the breaking changes were introduced.
dev-processor: export OTEL_IMAGE_TAG = 0.70.0
dev-processor: export OTEL_CONFIG_SRC = ./otel-collector-config-processor.yml
dev-processor: export PROMETHEUS_QUERY_SUPPORT_SPANMETRICS_CONNECTOR = false
dev-processor:
	docker compose -f docker-compose.yml up

.PHONY: clean-jaeger
clean-jaeger:
	# Also cleans up intermediate cached containers.
	docker system prune -f

.PHONY: clean-all
clean-all: clean-jaeger
	docker rmi -f jaegertracing/all-in-one:dev ; \
	docker rmi -f jaegertracing/all-in-one:latest ; \
	docker rmi -f otel/opentelemetry-collector-contrib:latest ; \
	docker rmi -f prom/prometheus:latest ; \
	docker rmi -f grafana/grafana:latest

=== examples/async/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ".")
set(PROJECT_EXAMPLE_NAME async)

file(GLOB EXAMPLE_SRC_FILES *.c)
include_directories(${INCLUDES})
add_executable(${PROJECT_EXAMPLE_NAME} ${EXAMPLE_SRC_FILES})
target_link_libraries(${PROJECT_EXAMPLE_NAME} ${PROJECT_LIB_NAME_TARGET} ${CASS_LIBS})
add_dependencies(${PROJECT_EXAMPLE_NAME} ${PROJECT_LIB_NAME_TARGET})

set_target_properties(${PROJECT_EXAMPLE_NAME} PROPERTIES FOLDER "Examples"
                                                         COMPILE_FLAGS "${EXAMPLE_CMAKE_C_FLAGS}")

=== examples/auth/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ".")
set(PROJECT_EXAMPLE_NAME auth)

file(GLOB EXAMPLE_SRC_FILES *.c)
include_directories(${INCLUDES})
add_executable(${PROJECT_EXAMPLE_NAME} ${EXAMPLE_SRC_FILES})
target_link_libraries(${PROJECT_EXAMPLE_NAME} ${PROJECT_LIB_NAME_TARGET} ${CASS_LIBS})
add_dependencies(${PROJECT_EXAMPLE_NAME} ${PROJECT_LIB_NAME_TARGET})

set_target_properties(${PROJECT_EXAMPLE_NAME} PROPERTIES FOLDER "Examples"
                                                         COMPILE_FLAGS "${EXAMPLE_CMAKE_C_FLAGS}")

=== changelog ===
python3.11 (3.11.2-6+deb12u2) bookworm; urgency=medium

  [ Steve McIntyre ]
  * Apply upstream security fix for CVE-2024-0450
    Protect zipfile from "quoted-overlap" zipbomb.
    Closes: #1070133
  * Apply and tweak upstream security fix for CVE-2023-6597
    tempfile.TemporaryDirectory: fix symlink bug in cleanup
    Closes: #1070135

  [ Stefano Rivera ]
  * Apply upstream patch to avoid a potential null pointer dereference in
    fileutils.
  * Apply upstream security fix for CVE-2023-41105
    os.path.normpath(): Path truncation at null bytes.
  * Apply upstream security fix for CVE-2023-40217
    Avoid bypass TLS of handshake protections on closed sockets.
  * Apply upstream security fix for CVE-2023-24329
    Strip C0 control and space characters in urlsplit.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 02 May 2024 07:59:08 -0400

python3.11 (3.11.2-6+deb12u1) bookworm; urgency=medium

  [ Anders Kaseorg ]
  * Fix a use-after-free crash when deallocating a frame object
    (closes: #1050843).

 -- Stefano Rivera <stefanor@debian.org>  Sat, 02 Mar 2024 16:28:50 -0400

python3.11 (3.11.2-6) unstable; urgency=high

  [ Stefano Rivera ]
  * Explain more ways to pass --break-system-packages to pip.

  [ Matthias Klose ]
  * Fix syntax error in python3-dbg-config script. LP: #2009967.

 -- Matthias Klose <doko@debian.org>  Mon, 13 Mar 2023 13:18:29 +0100

python3.11 (3.11.2-5) unstable; urgency=medium

  [ Matthias Klose ]
  * Update VCS attributes.
  * Fix error message for 'python3 -m venv dir`, when python3-venv
    is not installed. Closes: #1026268.

  [ Stefano Rivera ]
  * Mention that deleting EXTERNALLY-MANAGED is an option, in README.venv.
  * Patch: fix deadlock at shutdown when clearing thread states.
    Closes: #1032019.
  * Override expat embedded-library lintian false-positives. (See: #1031859)

 -- Matthias Klose <doko@debian.org>  Sun, 05 Mar 2023 09:28:49 +0100

python3.11 (3.11.2-4) unstable; urgency=medium

  [ Stefano Rivera ]
  * Revert the CCSHARED patch to test_customize_compiler, this was WIP and
    didn't work.

  [Matthias Klose]
  * Remove build dependency on libb2-dev, oldish library.
  * Build with internal mpdecimal library, so that mpdecimal can be removed
    for bookworm.

 -- Matthias Klose <doko@debian.org>  Sun, 12 Feb 2023 01:48:52 +0100

python3.11 (3.11.2-3) unstable; urgency=medium

  [ Stefano Rivera ]
  * Refresh patches.
  * Revert pip importlib.metadata workaround, fixed in pip 22.2.
  * Declare python3.11 to be PEP 668 EXTERNALLY-MANAGED.
  * Update and install README.venv, explaining this.
  * Recommend ca-certificates from python3.11. Closes: #960869.
  * Configure --with-ssl-default-suites=openssl. Closes: #1026802.
  * Update watch file.
  * Include CCSHARED override in distutils test_customize_compiler.

  [Matthias Klose]
  * Really new upstream version.
  * Configure --with-ssl-default-suites=openssl. Closes: #1009189.
  * Build-depend on libb2-dev.
  * Fix removing Debian build flags from _sysconfigdata. LP: #2006738.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Feb 2023 05:59:34 +0100

python3.11 (3.11.2-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 06 Feb 2023 21:27:04 +0100

python3.11 (3.11.1-2) unstable; urgency=medium

  * Fix NameError exception in venv init (Daniel Andersson). Closes: #1026448.
  * Fix FTCBFS: Pass --with-build-python (Helmut Grohne). Closes: #1024297.

 -- Matthias Klose <doko@debian.org>  Sat, 31 Dec 2022 11:23:59 +0100

python3.11 (3.11.1-1) unstable; urgency=medium

  * Python 3.11.1 release.

 -- Matthias Klose <doko@debian.org>  Wed, 07 Dec 2022 09:49:13 +0100

python3.11 (3.11.0-3) unstable; urgency=medium

  * Fix valgrind detection.

 -- Matthias Klose <doko@debian.org>  Fri, 04 Nov 2022 10:23:33 +0100

python3.11 (3.11.0-2) unstable; urgency=medium

  * Update to the 3.11 branch 2022-11-03.
    - debian/patches/CVE-2022-42919.patch: don't use Linux abstract sockets
      in Lib/multiprocessing/connection.py.
    - CVE-2022-42919
  * Fix GDB auto-load files. Closes: #1017913.
  * Add support for systemd-binfmt. Closes: #1013973.
  * libpython3.11-dev: Install Python.asdl and python.gram. Closes: #1022951.
  * Configure the python3-dbg interpreter --with-valgrind. Closes: #1006315.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 03 Nov 2022 16:41:50 +0100

python3.11 (3.11.0-1) unstable; urgency=medium

  * Python 3.11.0 release.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Mon, 24 Oct 2022 23:26:25 +0200

python3.11 (3.11.0~rc2-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * autopkgtests: Support python3-setuptools >= 64, which does PEP-660
    editable installs.

 -- Matthias Klose <doko@debian.org>  Sat, 01 Oct 2022 06:34:05 +0200

python3.11 (3.11.0~rc2-1) unstable; urgency=medium

  * Python 3.11.0 release candidate 2.

 -- Matthias Klose <doko@debian.org>  Mon, 12 Sep 2022 18:20:24 +0200

python3.11 (3.11.0~rc1-1) unstable; urgency=medium

  * Python 3.11.0 release candidate 1.
  * Add python3.11-venv as a dependency for the testsuite* autopkg tests.
  * Don't run the cppext test during the build.
  * Fix two site and sysconfig tests.

 -- Matthias Klose <doko@debian.org>  Wed, 10 Aug 2022 13:16:05 +0200

python3.11 (3.11.0~b4-2) unstable; urgency=medium

  * Work around https://github.com/pypa/pip/issues/11183.

 -- Matthias Klose <doko@debian.org>  Wed, 20 Jul 2022 12:00:00 +0200

python3.11 (3.11.0~b4-1) unstable; urgency=medium

  * Python 3.11.0 beta 4 snapshot.
  * Fix more references to 3.11 in the autopkg tests.
  * Update local-doc-references patch for 3.11.
  * Remove i386 specific symbols files.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Wed, 13 Jul 2022 11:00:16 +0200

python3.11 (3.11.0~b3-2) unstable; urgency=medium

  * Update symbols files for i386.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Jun 2022 16:59:45 +0200



=== debian/changelog ===
linux (6.1.106-3+ntap0) UNRELEASED; urgency=high

  * Apply the patches to fix libbfd-buildid compilation issues
  * Apply the patch to add runtime tuning support to dm-delay.c
  * Apply the patch to fix a use-after-free case in bond_3ad.c
  * Apply the NetApp SGA serial baud rate patch
  * Apply the NetApp sysfs extension to reload UEFI certs
  * Apply the NetApp patch to support second ttySx console for Solo
  * Apply the NetApp patch to hide log message about CDROM not ready on serial console

 -- NetApp Inc. <http://mysupport.netapp.com>  Thu, 12 Sep 2024 00:21:00 -0000

linux (6.1.106-3) bookworm; urgency=medium

  * udp: allow header check for dodgy GSO_UDP_L4 packets.
  * gso: fix dodgy bit handling for GSO_UDP_L4
  * net: more strict VIRTIO_NET_HDR_GSO_UDP_L4 validation
  * net: drop bad gso csum_start and offset in virtio_net_hdr (Closes: #1079684)
  * Bump ABI to 25

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 26 Aug 2024 21:47:39 +0200

linux (6.1.106-2) bookworm; urgency=medium

  * media: solo6x10: replace max(a, min(b, c)) by clamp(b, a, c)

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 22 Aug 2024 12:35:24 +0200

linux (6.1.106-1) bookworm; urgency=medium

  * New upstream stable update:
    https://www.kernel.org/pub/linux/kernel/v6.x/ChangeLog-6.1.100
    - Compiler Attributes: Add __uninitialized macro
    - mm: prevent derefencing NULL ptr in pfn_section_valid()
    - cachefiles: propagate errors from vfs_getxattr() to avoid infinite loop
    - cachefiles: narrow the scope of triggering EPOLLIN events in ondemand mode
    - cachefiles: stop sending new request when dropping object
    - cachefiles: cancel all requests for the object that is being dropped
    - cachefiles: wait for ondemand_object_worker to finish when dropping object
    - cachefiles: cyclic allocation of msg_id to avoid reuse
    - cachefiles: add missing lock protection when polling
    - filelock: fix potential use-after-free in posix_lock_inode
    - fs/dcache: Re-use value stored to dentry->d_flags instead of re-reading
    - vfs: don't mod negative dentry count when on shrinker list
    - tcp: fix incorrect undo caused by DSACK of TLP retransmit
    - net: phy: microchip: lan87xx: reinit PHY after cable test
    - skmsg: Skip zero length skb in sk_msg_recvmsg
    - net: fix rc7's __skb_datagram_iter()
    - i40e: Fix XDP program unloading while removing the driver
    - net: ethernet: lantiq_etop: fix double free in detach
    - bpf: Refactor some inode/task/sk storage functions for reuse
    - bpf: Reduce smap->elem_size
    - bpf: use bpf_map_kvcalloc in bpf_local_storage
    - bpf: Remove __bpf_local_storage_map_alloc
    - bpf: fix order of args in call to bpf_map_kvcalloc
    - net: ethernet: mtk-star-emac: set mac_managed_pm when probing
    - ppp: reject claimed-as-LCP but actually malformed packets
    - ethtool: netlink: do not return SQI value if link is down
    - udp: Set SOCK_RCU_FREE earlier in udp_lib_get_port().
    - net/sched: Fix UAF when resolving a clash
    - net, sunrpc: Remap EPERM in case of connection failure in
      xs_tcp_setup_socket
    - [s390x] Mark psw in __load_psw_mask() as __unitialized
    - firmware: cs_dsp: Fix overflow checking of wmfw header
    - firmware: cs_dsp: Return error if block header overflows file
    - firmware: cs_dsp: Validate payload length before processing block
    - firmware: cs_dsp: Prevent buffer overrun when processing V2 alg headers
    - firmware: cs_dsp: Use strnlen() on name fields in V1 wmfw files
    - cifs: fix setting SecurityFlags to true
    - Revert "sched/fair: Make sure to try to detach at least one movable task"
    - tcp: use signed arithmetic in tcp_rtx_probe0_timed_out()
    - tcp: avoid too many retransmit packets (CVE-2024-41007)
    - USB: serial: option: add Telit generic core-dump composition
    - USB: serial: option: add Telit FN912 rmnet compositions
    - USB: serial: option: add Fibocom FM350-GL
    - USB: serial: option: add support for Foxconn T99W651
    - USB: serial: option: add Netprisma LCUK54 series modules
    - USB: serial: option: add Rolling RW350-GL variants
    - USB: serial: mos7840: fix crash on resume
    - USB: Add USB_QUIRK_NO_SET_INTF quirk for START BP-850k
    - usb: gadget: configfs: Prevent OOB read/write in usb_string_copy()
    - USB: core: Fix duplicate endpoint bug by clearing reserved bits in the
      descriptor
    - hpet: Support 32-bit userspace
    - xhci: always resume roothubs if xHC was reset during resume
    - ksmbd: discard write access to the directory open
    - nvmem: rmem: Fix return value of rmem_read()
    - nvmem: meson-efuse: Fix return value of nvmem callbacks
    - nvmem: core: only change name to fram for current attribute
    - [x86] platform/x86: toshiba_acpi: Fix array out-of-bounds access
    - ALSA: hda/realtek: add quirk for Clevo V5[46]0TU
    - ALSA: hda/realtek: Enable Mute LED on HP 250 G7
    - ALSA: hda/realtek: Limit mic boost on VAIO PRO PX
    - Fix userfaultfd_api to return EINVAL as expected
    - libceph: fix race between delayed_work() and ceph_monc_stop()
    - ACPI: processor_idle: Fix invalid comparison with insertion sort for
      latency
    - wireguard: selftests: use acpi=off instead of -no-acpi for recent QEMU
    - wireguard: allowedips: avoid unaligned 64-bit memory accesses
    - wireguard: queueing: annotate intentional data race in cpu round robin
    - wireguard: send: annotate intentional data race in checking empty queue
    - [x86] retpoline: Move a NOENDBR annotation to the SRSO dummy return thunk
    - bpf: Allow reads from uninit stack
    - nilfs2: fix kernel bug on rename operation of broken directory
    - sched: Move psi_account_irqtime() out of update_rq_clock_task() hotpath
    - i2c: mark HostNotify target address as used
    - [x86] entry/64: Remove obsolete comment on tracing vs. SYSRET
    - [x86] bhi: Avoid warning in #DB handler due to BHI mitigation


=== packaging/debian/changelog ===
cassandra-cpp-driver (1.0.0-1) stable; urgency=low

  * Initial release

 -- Michael Penick <michael.penick@datastax.com>  Tue, 20 Jan 2015 20:20:27 -0700

=== control ===
Source: ntpsec
Section: net
Priority: optional
Maintainer: Richard Laager <rlaager@debian.org>
Build-Depends: asciidoctor,
               bison,
               debhelper-compat (= 13),
               dh-apache2,
               dh-apparmor,
               dh-python,
               docbook-xsl,
               libbsd-dev,
               libcap2-dev [linux-any],
               libssl-dev,
               netbase,
               pkg-config,
               pps-tools [linux-any],
               python3,
               python3-dev,
               python3-gps,
               systemd,
               xsltproc,
               xz-utils,
Build-Conflicts: libavahi-compat-libdnssd-dev,
                 libwww-dev,
                 libwww-ssl-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/ntpsec
Vcs-Git: https://salsa.debian.org/debian/ntpsec.git
Homepage: https://www.ntpsec.org

Package: ntpsec
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         lsb-base,
         netbase,
         python3,
         python3-ntp (= ${binary:Version}),
         tzdata,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: systemd | cron | cron-daemon,
Suggests: apparmor,
          certbot,
          ntpsec-doc,
          ntpsec-ntpviz,
Breaks: ntp (<< 1:4.2.8p15+dfsg-2~),
Conflicts: time-daemon,
Provides: time-daemon, sg-ntpsec
Replaces: ntp (<< 1:4.2.8p15+dfsg-2~),
          time-daemon,
Description: Network Time Protocol daemon and utility programs
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the NTP daemon and utility programs.  An NTP
 daemon needs to be running on each host that is to have its clock
 accuracy controlled by NTP.  The same NTP daemon is also used to
 provide NTP service to other hosts.
 .
 This is the NTPsec version of NTP.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 NTPsec supports Network Time Security (NTS) which provides
 cryptographically authenticated time.
 .
 For more information about the NTP protocol and NTP server
 configuration and operation, install the package "ntpsec-doc".

Package: ntpsec-ntpdate
Provides: sg-ntpsec-ntpdate
Architecture: any
Depends: netbase,
         ntpsec-ntpdig (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: ntpdate (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntpdate (<< 1:4.2.8p15+dfsg-2~),
Description: client for setting system time from NTP servers
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdate is a simple NTP client that sets a system's clock to match
 the time obtained by communicating with one or more NTP servers.  It
 is not sufficient, however, for maintaining an accurate clock in the
 long run.  ntpdate by itself is useful for occasionally setting the
 time on machines that do not have full-time network access, such as
 laptops.
 .
 This is the NTPsec version of ntpdate.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 .
 If the full NTP daemon from the package "ntpsec" is installed, then
 ntpsec-ntpdate is not necessary.

Package: ntpsec-ntpdig
Provides: sg-ntpsec-ntpdig
Architecture: any
Depends: python3 (>= 3.3),
         python3-ntp (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
        sntp (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
          sntp (<< 1:4.2.8p15+dfsg-2~),
Description: ntpdig SNTP client
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdig can be used as an SNTP client to query a NTP or SNTP server
 and either display the time or set the local system's time.  It is not
 sufficient, however, for maintaining an accurate clock in the long run.
 .
 This is the NTPsec version of ntpdig, which is equivalent to the sntp
 utility.  NTPsec is a secure, hardened, and improved implementation
 derived from the original NTP project.

Package: ntpsec-ntpviz
Provides: sg-ntpsec-ntpviz
Architecture: any
Depends: adduser,
         fonts-liberation,
         gnuplot-nox | gnuplot,
         python3,
         python3-ntp (= ${binary:Version}),
         systemd | cron | cron-daemon,
         ${misc:Depends},
Recommends: ntpsec,
            systemd | python3-psutil,
            ${misc:Recommends},
Suggests: python3-gps,
Description: NTP statistics graphing utility
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpviz analyzes NTP log files and generates statistical plots from
 them.  The output is in the form of HTML with images.  If Apache is
 installed, it will be served at: /ntpviz
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: ntpsec-doc
Provides: sg-ntpsec-doc
Architecture: all
Depends: ${misc:Depends},
Breaks: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
Section: doc
Multi-Arch: foreign
Description: Network Time Protocol documentation
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains HTML documentation for the ntpsec packages (ntpsec,
 ntpsec-ntpdate).
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: python3-ntp
Architecture: any
Depends: python3,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Provides: ${python3:Provides}, sg-python3-ntp
Section: python
Description: Python 3 NTP Helper Classes
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the Python "ntp" module, which contains helper
 classes for NTP utilities written in Python.
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: ntp
Provides: sg-ntp
Architecture: all
Section: oldlibs
Depends: ntpsec,
         ${misc:Depends},
Description: Network Time Protocol daemon/utilities (transitional package)
 This is a dummy transitional package to transition to NTPsec.
 It can be safely removed.

Package: ntp-doc
Provides: sg-ntp-doc
Architecture: all
Section: oldlibs
Depends: ntpsec-doc,
         ${misc:Depends},
Description: Network Time Protocol docs (transitional package)
 This is a dummy transitional package to transition to NTPsec.
 It can be safely removed.

Package: ntpdate
Provides: sg-ntpdate
Architecture: all
Section: oldlibs
Depends: ntpsec-ntpdate,
         ${misc:Depends},
Description: Network Time Protocol client (transitional package)
 This is a dummy transitional package to transition to NTPsec.
 It can be safely removed.

Package: sntp
Provides: sg-sntp
Architecture: all
Section: oldlibs
Depends: ntpsec-ntpdig,
         ${misc:Depends},
Description: Network Time Protocol client (transitional package)
 This is a transitional package to transition to NTPsec.
 It can be safely removed once all uses of sntp(1) have been converted to
 run ntpdig instead.

=== debian/control ===
Source: apache-arrow
Section: devel
Priority: optional
Maintainer: Apache Arrow Developers <dev@arrow.apache.org>
Build-Depends:
  cmake,
  debhelper (>= 12),
  git,
  gobject-introspection,
  gtk-doc-tools,
  libboost-filesystem-dev,
  libboost-system-dev,
  libbrotli-dev,
  libbz2-dev,
  libc-ares-dev,
  libcurl4-openssl-dev,
  libgirepository1.0-dev,
  libgoogle-glog-dev,
  libgrpc++-dev,
  libgtest-dev,
  liblz4-dev,
  libprotoc-dev,
  libprotobuf-dev,
  libre2-dev,
  libsnappy-dev,
  libssl-dev,
  libthrift-dev,
  libutf8proc-dev,
  libzstd-dev,
  ninja-build,
  nvidia-cuda-toolkit [!arm64],
  pkg-config,
  protobuf-compiler-grpc,
  python3-dev,
  python3-numpy,
  tzdata,
  zlib1g-dev
Build-Depends-Indep: libglib2.0-doc
Standards-Version: 3.9.8
Homepage: https://arrow.apache.org/

Package: libarrow700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends}
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files.

Package: libarrow-cuda700
Section: libs
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for CUDA support.

Package: libarrow-dataset700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow700 (= ${binary:Version}),
  libparquet700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Dataset module.

Package: libarrow-flight700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Flight RPC system.

Package: libarrow-python700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow700 (= ${binary:Version}),
  python3,
  python3-numpy
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Python support.

Package: libarrow-python-flight700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-flight700 (= ${binary:Version}),
  libarrow-python700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Flight and Python support.

Package: libarrow-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow700 (= ${binary:Version}),
  libbrotli-dev,
  libbz2-dev,
  libc-ares-dev,
  libgrpc++-dev,
  liblz4-dev,
  libre2-dev,
  libsnappy-dev,
  libssl-dev,
  libthrift-dev,
  libutf8proc-dev,
  libzstd-dev,
  protobuf-compiler-grpc,
  zlib1g-dev
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files.

Package: libarrow-cuda-dev
Section: libdevel
Architecture: i386 amd64
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libarrow-cuda700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for CUDA support.

Package: libarrow-dataset-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libarrow-dataset700 (= ${binary:Version}),
  libparquet-dev (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for dataset module.

Package: libarrow-flight-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libarrow-flight700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for Flight RPC system.

Package: libarrow-python-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libarrow-python700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for Python support.

Package: libarrow-python-flight-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-flight-dev (= ${binary:Version}),
  libarrow-python-dev (= ${binary:Version}),
  libarrow-python-flight700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for Flight and Python support.

Package: libgandiva700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow700 (= ${binary:Version})
Description: Gandiva is a toolset for compiling and evaluating expressions
 on Arrow Data.
 .
 This package provides C++ library files.

Package: libgandiva-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libgandiva700 (= ${binary:Version})
Description: Gandiva is a toolset for compiling and evaluating expressions
 on Arrow Data.
 .
 This package provides C++ header files.

Package: libplasma700
Section: libs
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-cuda700 (= ${binary:Version})
Description: Plasma is an in-memory object store and cache for big data.
 .
 This package provides C++ library files to connect plasma-store-server.

Package: plasma-store-server
Section: utils
Architecture: i386 amd64
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libplasma700 (= ${binary:Version})
Description: Plasma is an in-memory object store and cache for big data.
 .
 This package provides plasma-store-server.

Package: libplasma-dev
Section: libdevel
Architecture: i386 amd64
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-cuda-dev (= ${binary:Version}),
  libplasma700 (= ${binary:Version})
Description: Plasma is an in-memory object store and cache for big data.
 .
 This package provides C++ header files.

Package: libparquet700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends}
Description: Apache Parquet is a columnar storage format
 .
 This package provides C++ library files to process Apache Parquet format.

Package: libparquet-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libparquet700 (= ${binary:Version})
Description: Apache Parquet is a columnar storage format
 .
 This package provides C++ header files.

Package: libarrow-glib700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based library files.

Package: gir1.2-arrow-1.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends}
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GObject Introspection typelib files.

Package: libarrow-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libglib2.0-dev,
  libarrow-dev (= ${binary:Version}),
  libarrow-glib700 (= ${binary:Version}),
  gir1.2-arrow-1.0 (= ${binary:Version})
Suggests: libarrow-glib-doc
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based header files.

Package: libarrow-glib-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
  ${misc:Depends}
Recommends: libglib2.0-doc
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides documentations.

Package: libarrow-cuda-glib700
Section: libs
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-glib700 (= ${binary:Version}),
  libarrow-cuda700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based library files for CUDA support.

Package: gir1.2-arrow-cuda-1.0
Section: introspection
Architecture: i386 amd64
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends}
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GObject Introspection typelib files for CUDA support.

Package: libarrow-cuda-glib-dev
Section: libdevel
Architecture: i386 amd64
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-cuda-dev (= ${binary:Version}),
  libarrow-glib-dev (= ${binary:Version}),
  libarrow-cuda-glib700 (= ${binary:Version}),
  gir1.2-arrow-cuda-1.0 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based header files for CUDA support.

Package: libarrow-dataset-glib700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-glib700 (= ${binary:Version}),
  libarrow-dataset700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based library files for dataset module.

Package: gir1.2-arrow-dataset-1.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends}
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GObject Introspection typelib files for dataset module.

Package: libarrow-dataset-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dataset-dev (= ${binary:Version}),
  libarrow-glib-dev (= ${binary:Version}),
  libarrow-dataset-glib700 (= ${binary:Version}),
  gir1.2-arrow-dataset-1.0 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based header files for dataset module.

Package: libarrow-dataset-glib-doc
Section: doc
Architecture: any
Multi-Arch: foreign
Depends:
  ${misc:Depends}
Recommends: libarrow-glib-doc
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides documentations for dataset module.

Package: libarrow-flight-glib700
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-glib700 (= ${binary:Version}),
  libarrow-flight700 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based library files for Apache Arrow Flight.

Package: gir1.2-arrow-flight-1.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends}
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GObject Introspection typelib files for Apache Arrow
 Flight.

Package: libarrow-flight-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-flight-dev (= ${binary:Version}),
  libarrow-glib-dev (= ${binary:Version}),
  libarrow-flight-glib700 (= ${binary:Version}),
  gir1.2-arrow-flight-1.0 (= ${binary:Version})

=== packaging/debian/control ===
Source: cassandra-cpp-driver
Priority: extra
Maintainer: Michael Penick <michael.penick@datastax.com>
Build-Depends: debhelper (>= 9.0.0), dh-exec, cmake, make,
        libuv1-dev (>= 1.0.0),
        libssl-dev
Standards-Version: 3.9.2
Section: libs
Homepage: http://datastax.github.io/cpp-driver/
Vcs-Git: git://github.com/datastax/cpp-driver.git
Vcs-Browser: https://github.com/datastax/cpp-driver

Package: cassandra-cpp-driver
Section: libs
Architecture: any
Pre-Depends: libc6 (>= 2.3.6-2), ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C/C++ client driver for Apache Cassandra and DataStax Products - runtime library
 A modern, feature-rich, and highly tunable C/C++ client library for Apache
 Cassandra and DataStax Products using Cassandra's native protocol and Cassandra Query
 Language along with extensions for DataStax Products.

Package: cassandra-cpp-driver-dev
Section: libdevel
Architecture: any
Depends: cassandra-cpp-driver (= ${binary:Version}), ${misc:Depends}
Description: C/C++ client driver for Apache Cassandra and DataStax Products - development files
 A modern, feature-rich, and highly tunable C/C++ client library for Apache
 Cassandra and DataStax Products using Cassandra's native protocol and Cassandra Query
 Language along with extensions for DataStax Products.

Package: cassandra-cpp-driver-dbg
Section: debug
Architecture: any
Depends: cassandra-cpp-driver (= ${binary:Version}), ${misc:Depends}
Description: C/C++ client driver for Apache Cassandra and DataStax Products - debugging symbols
 A modern, feature-rich, and highly tunable C/C++ client library for Apache
 Cassandra and DataStax Products using Cassandra's native protocol and Cassandra Query
 Language along with extensions for DataStax Products.

=== src/packaging/debian/control ===
# Copyright 2014-2017 Spotify AB
# Copyright 2016-2018 The Last Pickle Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

Source: cassandra-reaper
Section: non-free/net
Priority: extra
Maintainer: Bjorn Hegerfors <bj0rn@spotify.com>
Uploaders: Hannu Varjoranta <hannu.varjoranta@iki.fi>,
           Jimmy Mardell <yarin@spotify.com>,
           Radovan Zvoncek <zvo@spotify.com>
Build-Depends: debhelper (>= 7), java7-jdk, maven
Standards-Version: 3.7.2

Package: cassandra-reaper
Architecture: all
Depends: java7-runtime
Description: Software to run automated (anti-entropy) repairs of Cassandra cluster data

Package: cassandra-reaper-cli
Architecture: all
Depends: python-requests
Description: Python based CLI tool for calling the Reaper service

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file - for binutils (2.29)
# Based on sample debian/rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# Copyright 1998-2007 James Troup.
# Portions Copyright 2008-2022 Canonical Ltd.
# Portions Copyright 2008-2022 Matthias Klose.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified

###############################################################################

include /usr/share/dpkg/pkg-info.mk

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS := $(shell dpkg-architecture)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_GNU_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_CPU)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq (,$(filter no, $(DEB_RULES_REQUIRES_ROOT)))
  require_root = yes
endif
ifeq ($(require_root),yes)
  CHOWN = chown
  DPKG_DEB = dpkg-deb
else
  CHOWN = : chown
  DPKG_DEB = dpkg-deb --root-owner-group
endif

ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy jessie))
  ifeq ($(DEB_HOST_GNU_TYPE),i586-linux-gnu)
    DEB_BUILD_GNU_TYPE	= i686-linux-gnu
    DEB_HOST_GNU_CPU	= i686
    DEB_HOST_GNU_TYPE	= i686-linux-gnu
    TRIPLET_SYMLINK	= i586-linux-gnu
  else ifeq ($(DEB_HOST_GNU_TYPE),i586-kfreebsd-gnu)
    DEB_BUILD_GNU_TYPE	= i686-kfreebsd-gnu
    DEB_HOST_GNU_CPU	= i686
    DEB_HOST_GNU_TYPE	= i686-kfreebsd-gnu
    TRIPLET_SYMLINK	= i586-kfreebsd-gnu
  else ifeq ($(DEB_HOST_GNU_TYPE),i586-gnu)
    DEB_BUILD_GNU_TYPE	= i686-gnu
    DEB_HOST_GNU_CPU	= i686
    DEB_HOST_GNU_TYPE	= i686-gnu
    TRIPLET_SYMLINK	= i586-gnu
  endif
endif

p_bin = binutils
p_com = $(p_bin)-common
p_lib = lib$(p_bin)
p_nat = $(p_bin)-$(subst _,-,$(DEB_HOST_GNU_TYPE))
p_dev = $(p_bin)-dev
p_mul = $(p_bin)-multiarch
p_mdev = $(p_mul)-dev
p_doc = $(p_bin)-doc
p_hppa64 = $(p_bin)-hppa64-linux-gnu
p_src = $(p_bin)-source

p_ctf = libctf0
p_ctfn = libctf-nobfd0
p_gpng = libgprofng0

p_hst = $(p_bin)-for-host
p_bld = $(p_bin)-for-build

p_cross = $(p_bin)-$(subst _,-,$(DEB_TARGET_GNU_TYPE))

# version used for p_bld/p_hst dependencies
min_ver = 2.30-2

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
ifeq ($(distrelease),n/a)
  distrelease     := sid
endif

# BACKPORT is used for cross builds for a -source package not conflicting
# with the source package of the native package.
ifeq ($(BACKPORT),true)
  p_src = $(p_bin)-$(VERSION)-source
else
  p_src = $(p_bin)-source
endif

pwd   := $(shell pwd)
d     = debian/tmp
d_bin = $(d)
d_com = debian/$(p_com)
d_lib = debian/$(p_lib)
d_nat = debian/$(p_nat)
d_dev = debian/$(p_dev)
d_mul = debian/$(p_mul)
d_mdev = debian/$(p_mdev)
d_doc = debian/$(p_doc)
d_hppa64 = debian/$(p_hppa64)
d_src = debian/$(p_src)

d_ctf = debian/$(p_ctf)
d_ctfn = debian/$(p_ctfn)
d_gpng = debian/$(p_gpng)

d_hst = debian/$(p_hst)
d_bld = debian/$(p_bld)

d_cross = debian/$(p_cross)

install_dir    = install -d -m 755
install_file   = install -m 644
install_script = install -m 755
install_binary = install -m 755 -s --strip-program="$(STRIP)"

NATIVE_ARCHS ?= amd64 i386 arm64 armhf armel ppc64el s390x
NATIVE_ARCHS += alpha arc hppa ia64 m68k powerpc ppc64 \
	riscv64 sh4 sparc64 x32
NATIVE_ARCHS += hurd-i386 kfreebsd-amd64 kfreebsd-i386
#NATIVE_ARCHS += nios2 or1k s390 sparc

# don't generate the control file entries for native packages which are never
# built. Only valid for Ubuntu. The autopkg testers get confused otherwise
ifneq ($(distribution)-$(CROSS_ARCHS),Ubuntu-)
  NATIVE_ARCHS += mips mipsel mips64 mips64el
  NATIVE_ARCHS += mipsn32 mipsn32el
  NATIVE_ARCHS += mipsn32r6 mipsn32r6el mipsr6 mipsr6el mips64r6 mips64r6el
endif

with_cross = yes
ifeq ($(DEB_SOURCE),binutils)
  with_native	= yes
  same_source	= yes
  ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386 x32))
    # DEB_HOST_ARCH is filtered-out later anyway, do not test here.
    CROSS_ARCHS ?= amd64 i386 x32 \
                   s390x ppc64el arm64 armhf armel \
                   alpha arc hppa m68k \
                   powerpc ppc64 sh4 sparc64 \
                   ia64 riscv64 \
                   kfreebsd-amd64 kfreebsd-i386 hurd-i386
  else ifeq ($(DEB_HOST_ARCH),arm64)
    CROSS_ARCHS ?= amd64 armel armhf i386 ppc64el riscv64 s390x arc x32
  else ifeq ($(DEB_HOST_ARCH),ppc64)
    CROSS_ARCHS ?= ppc64el
  else ifeq ($(DEB_HOST_ARCH),ppc64el)
    CROSS_ARCHS ?= powerpc ppc64 amd64 i386 x32 arm64 armel armhf riscv64 s390x
  endif
else ifeq ($(DEB_SOURCE),binutils-ports)
  CROSS_ARCHS ?= m68k sh4
else ifeq ($(DEB_SOURCE),binutils-mipsen)
  with_native	=
  same_source	=
  ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386 x32 arm64 ppc64el))
    CROSS_ARCHS ?= mips mipsel mips64el mips64 mipsn32 mipsn32el \
                   mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el
  else ifneq (,$(filter $(DEB_HOST_ARCH), arm64 ppc64el))
    CROSS_ARCHS ?= mipsel mips64el
  endif
else
  $(error unexpected source package name: $(DEB_SOURCE))
endif
# c-t-b passes this one ...
CROSS_ARCHS := $(filter-out $(DEB_HOST_ARCH),$(CROSS_ARCHS))

ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 x32 hppa))
  with_hppa64 = yes
endif

with_multiarch := yes

# disabled: no build-needed restriction used in the autopkg test
ifeq (0,1)
# only build the basic package when running the autopkg tests
ifneq (,$(ADT_TEST_TRIGGERS))
  # c-t-b sets CROSS_ARCHS which has to be respected, can't unset it here
  #CROSS_ARCHS :=
  with_hppa64 :=
  with_multiarch :=
endif
endif

ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 arm64 x32))
  with_gprofng = yes
  CONF_GPROFNG = --enable-gprofng
endif

HOST_ARCHS_arc = amd64 i386 x32 arm64
HOST_ARCHS_armhf = amd64 i386 x32 arm64 ppc64el
HOST_ARCHS_armel = amd64 i386 x32 arm64 ppc64el
HOST_ARCHS_arm64 = amd64 i386 x32 ppc64el
HOST_ARCHS_powerpc = amd64 i386 x32 ppc64el
HOST_ARCHS_ppc64el = amd64 i386 x32 ppc64 arm64
HOST_ARCHS_s390x = amd64 i386 x32 arm64 ppc64el
HOST_ARCHS_amd64 = arm64 i386 ppc64el x32
HOST_ARCHS_i386 = amd64 arm64 ppc64el x32
HOST_ARCHS_ia64 = amd64 i386 x32
HOST_ARCHS_riscv64 = amd64 i386 x32 arm64 ppc64el

HOST_ARCHS_alpha = amd64 i386 x32
#HOST_ARCHS_arc = amd64 i386 x32
HOST_ARCHS_hppa = amd64 i386 x32
HOST_ARCHS_m68k = amd64 i386 x32
HOST_ARCHS_ppc64 = amd64 i386 x32 ppc64el
HOST_ARCHS_sh4 = amd64 i386 x32
HOST_ARCHS_sparc64 = amd64 i386 x32
HOST_ARCHS_x32 = amd64 arm64 i386 ppc64el

HOST_ARCHS_mips = amd64 i386 x32
HOST_ARCHS_mipsel = amd64 i386 x32 arm64 ppc64el
HOST_ARCHS_mipsn32 = amd64 i386 x32
HOST_ARCHS_mipsn32el = amd64 i386 x32
HOST_ARCHS_mips64 = amd64 i386 x32
HOST_ARCHS_mips64el = amd64 i386 x32 arm64 ppc64el

HOST_ARCHS_mipsr6 = amd64 i386 x32
HOST_ARCHS_mipsr6el = amd64 i386 x32
HOST_ARCHS_mipsn32r6 = amd64 i386 x32
HOST_ARCHS_mipsn32r6el = amd64 i386 x32
HOST_ARCHS_mips64r6 = amd64 i386 x32
HOST_ARCHS_mips64r6el = amd64 i386 x32

HOST_ARCHS_kfreebsd-amd64 = amd64 i386 x32
HOST_ARCHS_kfreebsd-i386 = amd64 i386 x32
HOST_ARCHS_hurd-i386 = amd64 i386 x32

# Map a Debian architecture alias to a GNU type or a multiarch path component.
run_dpkg_arch = $(or $(dpkg_arch_$1),$(eval \
  dpkg_arch_$1 := $(shell dpkg-architecture -f -a$1))$(dpkg_arch_$1))
_gnu_type  = $(call vafilt,$(run_dpkg_arch),DEB_HOST_GNU_TYPE)
_multiarch = $(call vafilt,$(run_dpkg_arch),DEB_HOST_MULTIARCH)

# Convenient shortcuts for {configure,build,install,binary}.%: generic recipes.
CROSS_ARCH	= $(subst .,,$(suffix $@))
CROSS_GNU_TYPE	= $(subst i586,i686,$(call _gnu_type,$(CROSS_ARCH)))
P_CROSS		= binutils-$(subst _,-,$(CROSS_GNU_TYPE))
D_CROSS		= debian/$(P_CROSS)

# If $(TARGET) is not set, try reading debian/target
ifeq (,$(TARGET))
